        list      p=16f876              ;list directive to define processor
        #include <p16f876.inc>                  ; processor specific variable defenitions

#define         TXTBLOCKTABH            0x01    ;Tabelle mit den adressen zu den textblocknummern
#define         TXTBLOCKTABL            0x00

#define         TXTFOLGETABH            0x01    ;Tabelle mit Textblocknummernfolge
#define         TXTFOLGETABL            0x80

#define         TextspeicherH           0x02            ;page 0    ab 0200Hex
#define         TextspeicherL           0x00            ;page 0    

#define         sysH                    0x0C
#define		sysL			0x00

#define         ZeichensatzH            0x10            ;page 2    ab 1000Hex
#define		ZeichensatzL		0x00		;page 2

#define         BCD2ScancodeTABH        0x15
#define         BCD2ScancodeTABL        0x00

#define		ShiftVelocityADDRH	0x00
#define		ShiftVelocityADDRL	0x0C

#define		VideoMEM		0x10		;Bank 1 ab 110Hex

#define         Spaltenbreite           0x0C            ;Displaybreite in byte
#define         Keyclock                PORTB,0
#define		Keydata			PORTB,1
#define         Datapinvert             PORTB,5
#define		Clockpinvert		PORTB,2
#define         Storepin                PORTB,4

#define         GREENPIN                PORTA,2
#define         REDPIN                  PORTA,3
#define         Blinkbit                PORTA,1         ;Blinkleitung geht an OUTPUT ENABLE

#define		Virtualchar		0x80		;Offset->Adresse ist VideoMEM+0x80 
#define         timetoblink             0x15            ;cursor blink_Zeit

#define         Cursorbit               Devicestatus,0	;Wenn Bit Ein Blinkt der Cursor
#define		ClockEnableBit		Devicestatus,1	;Gibt an ob clock geprintet werden soll wenn clockbit gesetzt ist
#define		BlinkEnableBit		Devicestatus,2	;Wenn 1 dann Blinkt es ,wenn modusByte,2 auch Ein ist
#define		nexttextbit		Devicestatus,3	;Gibt Zeit fuer die Texte an
#define		F2ModeBit		Devicestatus,4	;Ist 1 wenn F2Mode an ist
#define		ModusBlinkBit		Devicestatus,5	; wird zum blinken des ModusAnzeigezeichens im F3Mode benutzt
#define		NoDelayBit		Devicestatus,6	;Wird bei Flash_it benutzt um verzoegerung auszuschalten
#define		clockbit		Devicestatus,7	;Wenn dies bit An -> uhr printen


#define         TIMEOUT_BIT             Keystatus,0	;TastaturZeichenuetertragsZeit
#define         KBE0_Bit                Keystatus,1	;Bit fuer Extendet Key
#define         KBF0_Bit                Keystatus,2	;Bit fuer das Breaksignal
#define         taste                   Keystatus,3	;Bit fuer neue Taste ist da
#define         Shiftbit                Keystatus,4	;Bit gesetzt solange Shifttaste gedrueckt ist

#define         HCMAX                   0x0D		;Cursorbegrenzung im editmode
#define         HCMIN                   0x01		;CursorBegrenzung im Editmode


#define         CharOffsetCountMIN      0x00		;
#define         CharOffsetCountHighMIN  0x00

#define         CharOffsetCountMax      0xFE            ;Vormals FF
#define         CharOffsetCountHighMAX  0x0B

#define		TXTFOLGECOUNTERMAX	0x3C	;Max Lnge Der TextFolgeListe

#define         TXTANZAHLMAX            0x3C	;max anzahl der textbloecke




;***** VARIABLE DEFINITIONS
CharOffset              EQU     0x20            ;Zeichenoffset in byteabstand von 0200H aus (1800Hex+Offset=Zeichenanfang)
Cursor                  EQU     0x21            ;Zaehler fuer die Position auf dem anzeigefeld
VideomemFSR_Temp        EQU     0x22            ;zwischenspeicher fuer FSR_Reg in der InterruptService routine  !!!!
CharOffsetCount         EQU     0x23		;16BIT
CharOffsetCountH        EQU     0x24            ;Zaehler im Textspeicher. Position im Textspeicher = CharOffsetCount
Devicestatus            EQU     0x25            ;Satus_Bits fuer die Anzeige
						;Bit 0		1= Cursor ON
                                                ;Bit 1          ClockEnable_Bit
                                                ;Bit 2          
						;Bit 3		ON = Zeit fuer den naechsten Text ist erreicht
                                                ;Bit 4          ON = (anzeige)F2-Modus ist an
                                                ;Bit 5          ModusBlinkBit
						;Bit 6		Runmode ON
                                                ;Bit 7		ClockBit          
time1                   EQU     0x26            ;Fuer           ISR reserviert
time2                   EQU     0x27            ;Fuer           ISR reserviert
time3                   EQU     0x28            ;Fuer           ISR reserviert
ISRCOUNT                EQU     0x29            ;Fuer           ISR reserviert
CharPos                 EQU     0x2A            ;Ausgabeposition des Zeichens
SearchCounter           EQU     0x2B
Hilfsbyte               EQU     0x2C            ;HilfsByte zum rotieren
ShiftVelocity		EQU	0x2D		;Zahl gibt die geschindigkeit zum rotieren an
Shifttimer              EQU     0x2E            ;Zum rotieren der timer
RotateCounter		EQU	0x2F		;Zeahl wie oft schon rotiert wurde


TextblockNr             EQU     0x31
HC1                     EQU     0x32
HC2                     EQU     0x33
Counter                 EQU     0x34
TEMP                    EQU     0x35
TEMPM			EQU	0x36
TEMPH                   EQU     0x37

Cursortimer             EQU     0x38
copytovideoloop1        EQU     0x39
copytovirtualloop1      EQU     0x3A
rotateloop1             EQU     0x3B
rotateloop2             EQU     0x3C
KeyCode1                EQU     0x3D            ;KeyBoard Variablen

KeyBit                  EQU     0x3F            ;Zahler fuer tastaturBits
Scancode                EQU     0x40
ModusChar		EQU	0x41
Keystatus               EQU     0x42
TimeOutCounter          EQU     0x43
Zeilenzaehler           EQU     0x44            ;Zaehler fuer die Zeile
Spaltenbyte             EQU     0x45            ;Zaehler fuer VideoMEM_Diplayausgabe
loop1                   EQU     0x46            ;Varaible used for counting
loop2                   EQU     0x47            ;
ByteNr                  EQU     0x48
Rest                    EQU     0x49
Restloop                EQU     0x4A
Videobyte1              EQU     0x4B
Videobyte2              EQU     0x4C
MaskByte1               EQU     0x4D
MaskByte2               EQU     0x4E
TXTFOLGECOUNTER         EQU     0x4F
ModusByte               EQU     0x50
TabellenCounter         EQU     0x51

LSD                     EQU     0x52
MSD                     EQU     0x53
TXTBlockScanCodeH	EQU	0x54
TXTBlockScanCodeL	EQU	0x55

CByteNr                 EQU     0x56		;
CRest                   EQU     0x57
CRestloop               EQU     0x58
CMaskByte1              EQU     0x59
CMaskByte2              EQU     0x5A
flashloop1		EQU	0x5B
DelayL			EQU	0x5C
DelayH			EQU	0x5D
sysnr			EQU	0x5E
time_for_nexttext       EQU	0x5F
Farbe			EQU	0x60
ClockCharTemp		EQU	0x61
ClockCharOffset		EQU	0x62
sec_L			EQU	0x63
sec_H			EQU	0x64
min_L			EQU	0x65
min_H			EQU	0x66
std_L			EQU	0x67
std_H			EQU	0x68



w_temp                  EQU     0x73            ;variable used for context saving
status_temp             EQU     0x74            ;variable used for context saving
pclath_temp             EQU     0x75            ;variable used for context saving               
FSR_Temp                EQU     0x76            ;fuer ISR reserviert
DATAL                   EQU     0x77
DATAH                   EQU     0x78
ADDRL                   EQU     0x79
ADDRH                   EQU     0x7A
FWDATAL                 EQU     0x7B
FWDATAH                 EQU     0x7C
FWADDRL                 EQU     0x7D
FWADDRH                 EQU     0x7E
Zeit			EQU	0x7F
                                                ; Start at the reset vector
		ORG	0x000			; processor reset vector
                clrf    PCLATH                  ; 0 ensure page bits are cleared
                bsf     PCLATH,3
                bsf     PCLATH,4
                goto    main                    ; 3

                ORG     0x004                   ; 4 interrupt vector location
                bsf     PCLATH,3
                bsf     PCLATH,4
                goto    Service

		org	0x000c			;anfangsWert fuer Shiftvelocity
		DW	0x0002

                org     0x1800
Service         movwf   w_temp                  ; save off current W register contents
                movf    STATUS,W                ; move status register into W register
                movwf   status_temp             ; save off contents of STATUS register
		movf	FSR,W
                movwf   FSR_Temp                ;FSR_Register Retten
                BCF     STATUS,RP0
                BCF     STATUS,RP1
                BSF     STATUS,IRP
;***************************************************************************
;***            Zeitsteuerung                                            ***
;***************************************************************************

;***************************************************************************
			btfss	PIR1,TMR1IF
			goto	NO_CLOCK_INT
Clock			bcf	PIR1,TMR1IF
			incf	sec_L,F	
			incf	sec_L,F	
			movlw	0x0A
			xorwf	sec_L,W
			btfss	STATUS,Z
			goto	clockend
			clrf	sec_L
			incf	sec_H,F
			movlw	0x06
			xorwf	sec_H,W
			btfss	STATUS,Z
			goto	clockend
			clrf	sec_H
			incf	min_L,F
			movlw	0x0A
			xorwf	min_L,W
			btfss	STATUS,Z
			goto	clockend
			clrf	min_L
			incf	min_H,F
			movlw	0x06
			xorwf	min_H,W
			btfss	STATUS,Z
			goto	clockend
			clrf	min_H
			incf	std_L,F
			movlw	0x0A
			xorwf	std_L,W
			btfss	STATUS,Z
			goto	clockend
			clrf	std_L		
			incf	std_H,F
clockend
			movlw	0x02
			xorwf	std_H,W
			btfss	STATUS,Z
			goto	NOT24
			movlw	0x04
			xorwf	std_L,W
			btfss	STATUS,Z
			goto	NOT24
			clrf	std_H
			clrf	std_L
NOT24
			btfsc	clockbit
			call	clockprint

NO_CLOCK_INT
			btfss	INTCON,T0IF
			goto	NO_TIMER_INT	;Zeit erhoehen und gegebenenfalls cursor blinken
;****************************************************************************
;*********** Ausgabe des VideoMEM auf die schieberegister            ********
;****************************************************************************
refresh_display		movf	VideomemFSR_Temp,W	;Pointer auf das Videomem fuer Interruptroutine
			movwf	FSR			;FSR mit VideoMEM_adresse laden
			movf	INDF,W			;
			xorlw	0xFF
			movwf	SSPBUF			;An das SSP uebergeben
                        incf    FSR,F
			decfsz	Spaltenbyte,F
			goto	endcycle
                        movlw   Spaltenbreite           ;Zaehler fuer
			movwf	Spaltenbyte		;4 Byte aus videomem
Store                   BSF     Storepin                ;StoreSignal an			NOP
                        NOP
                        NOP
                        BCF     Storepin                ;StoreSignal aus
zeilenzaehlersetzen     BSF     Clockpinvert
                        NOP
                        BCF     Clockpinvert
			decfsz	Zeilenzaehler,F
			goto	endcycle
Zz_reset                BSF     Datapinvert
                        BSF     Clockpinvert
                    incf    Shifttimer,F
                        BCF     Clockpinvert
                        BCF     Datapinvert
                        BSF     Zeilenzaehler,3         ;eine 0x08 in Zeilenzaehler
                        MOVLW   VideoMEM                ;VideoMEMPointer in das
			MOVWF	FSR			;FSR Register
endcycle                movf    FSR,W
			movwf	VideomemFSR_Temp
;                        call    KeyDisplay
;************************************************************************************************
Timecheck               bcf     INTCON,T0IF             ;clear Timer0IntFlag
;                        movf    time1,W
;                        andlw   B'00111111'
;                        btfsc   STATUS,Z
;                        incf    Shifttimer,F
			incf	time1,F			;********Timer 1
			btfss	STATUS,Z
			goto	EndOfTimeCheck
                                                        ;*********timer 2
                        incf    TimeOutCounter,F
                        btfsc   TimeOutCounter,1        ;32*255*235nS=1.8ms
                        bsf     TIMEOUT_BIT
IS_NOT_TimeOut          btfsc   cursorbit               ;wenn Cursorbit = ON ,dann Cursor_blinken
			call	CursorBlink
			incf	time2,F
			movf	time2,W
			iorlw	0xF0
			xorlw	0xFF
			btfss	STATUS,Z
			goto	EndOfTimeCheck
							;**********Timer 3
			btfss	Devicestatus,4		;F2 Mode an ?
			Goto	NichtBlinken
			btfss	BlinkEnableBit
			Goto	NichtBlinken
			btfss	ModusByte,2		;
			goto	NichtBlinken		;
Blinken			btfss	BlinkBit
			Goto	Blinkbitsetzen
			bcf	BlinkBit
			Goto	weitermachen
Blinkbitsetzen		bsf	Blinkbit
			Goto	weitermachen
NichtBlinken		bsf	Blinkbit
Weitermachen		
			incf	time3,F
			movf	time_for_nexttext,W
			xorwf	time3,W
			btfss	Status,Z
			goto	EndOfTimeCheck
			clrf	time3			;timer3reset

			bsf	nexttextbit		;Bit fuer den naechsten Text
EndOfTimeCheck
;*************************************************************************
NO_TIMER_INT            btfss   INTCON,INTF
                        Goto    NoKeyPressed
getkeydata              btfss   TIMEOUT_BIT
                        GOTO    TIMEOUT_NOT
TIMEOUT                 clrf    Keybit
                        bcf     TIMEOUT_BIT
TIMEOUT_NOT             clrf    TimeOutCounter
                        movf    Keybit,W                        ;StartBit ueberspringen
			btfsc	STATUS,Z
			goto	Override_Bit
			movf	Keybit,W			;parityBit ueberspringen
			xorlw	0x09
			btfsc	STATUS,Z
			goto	Override_Bit
			movf	Keybit,W			;StopBit ueberspringen
			xorlw	0x0A
			btfsc	STATUS,Z
			goto	Override_Bit
			bsf	STATUS,C
			btfss	PORTB,1
			bcf	STATUS,C
			rrf	Scancode,F
Override_Bit		incf	Keybit,F
			movf	Keybit,W
			xorlw	0x0B
			btfss	STATUS,Z
			GOTO	KEY_ROUTINE_EXIT
STOREKEYBYTE		CLRF	Keybit			;Reset Bit_Zaehler
Test_For_E0             movf    Scancode,W              ;TEST for Scancode E0
			xorlw	0xE0
			btfss	STATUS,Z
                        GOTO    Scancode_NOT_E0
Scancode_IS_E0		bsf	KBE0_Bit
			GOTO	KEY_ROUTINE_EXIT
Scancode_NOT_E0
F0_Test			movf	Scancode,W		;TEST for Scancode F0
			xorlw	0xF0
			btfss	STATUS,Z
			GOTO	IS_NOT_F0
Scancode_IS_F0		bsf	KBF0_Bit
			GOTO	KEY_ROUTINE_EXIT
IS_NOT_F0
BreakBit_Test		btfss	KBF0_Bit
			GOTO	BreakBit_NOT_SET
BreakBit_is_SET
Test_For_Shift_Break_R  movf    Scancode,W
                        xorlw   0x59
                        btfss   STATUS,Z
                        Goto    NOT_SHIFT_BREAK_R
IT_IST_SHIFT_BREAK_R    bcf     Shiftbit
                        Goto    Shift_Break_Exit
NOT_SHIFT_BREAK_R       
Test_For_Shift_Break_L  movf    Scancode,W
                        xorlw   0x12
                        btfss   STATUS,Z
                        Goto    NOT_SHIFT_BREAK_L
IT_IST_SHIFT_BREAK_L    bcf     Shiftbit
                        Goto    Shift_Break_Exit
NOT_SHIFT_BREAK_L       

Shift_Break_Exit
                        bcf     KBF0_Bit
                        bcf     KBE0_Bit
			GOTO	KEY_ROUTINE_EXIT
BreakBit_NOT_SET
Test_For_Shift_R        movf    Scancode,W
                        xorlw   0x59
                        btfss   STATUS,Z
                        goto    NOT_SHIFT_KEY_R
                        bsf     Shiftbit
                        Goto    Shift_Key_Exit
NOT_SHIFT_KEY_R
Test_For_Shift_L        movf    Scancode,W
                        xorlw   0x12
                        btfss   STATUS,Z
                        goto    NOT_SHIFT_KEY_L
                        bsf     Shiftbit
                        Goto    Shift_Key_Exit
NOT_SHIFT_KEY_L
Test_Code1_Equal_Code2  movf    Scancode,W
                        movwf   KeyCode1
                        bsf     taste
Shift_Key_Exit
KEY_ROUTINE_EXIT        bcf     INTCON,INTF
NoKeyPressed
;*****************************************************************************
 		movf	FSR_Temp,W		; FSR_Register Zurckladen
		movwf	FSR
                movf    status_temp,w           ; retrieve copy of STATUS register
                movwf   STATUS                  ; restore pre-isr STATUS register contents
		swapf  	w_temp,f
                swapf   w_temp,w                ; restore pre-isr W register contents
                retfie                          ; return from interrupt
;****************************E N D E  Der Interrupt_Routine*******************

;******************************************************************************************
;***					Cursor						***
;***		hole an pos cursor data aus videomem und invertiere sie 		***
;******************************************************************************************
CursorBlink		incf	Cursortimer,F
			movf	Cursortimer,W
			xorlw	timetoblink
			btfss	STATUS,Z
		return
			clrf	Cursortimer
bitsetcont           
			movf		Cursor,W
                        movwf           CByteNr

                                                        ;CByteNr  * 7 
                        bcf             STATUS,C
                        rlf             CByteNr,W       ;2*CByteNr->W_Reg
                        addwf           CByteNr,F       ;CByteNr + 2*CByteNr
                        addwf           CByteNr,F       ; + 2*CByteNr
                        addwf           CByteNr,F       ; + 2*CByteNr
                                                        ;Geteilt Durch 8 und den Rest in CRest schieben
                        clrf            CRest
                        bcf             STATUS,C
                        rrf             CByteNr,F
                        rrf             CRest,F
                        rrf             CByteNr,F
                        rrf             CRest,F
                        rrf             CByteNr,F
                        rrf             CRest,F
                                                        ;Den Rest um 5 stellen weiterschieben
                        rrf             CRest,F                  ;0xxx0000
                        Swapf           CRest,F                  ;00000xxx

                        movlw           0xFE
                        movwf           CMaskByte1

                        movlw           0x00
                        movwf           CMaskByte2

                        movf            CRest,W
                        movwf           CRestloop
                        btfsc           STATUS,Z
                        goto            Crestistnull
Crechenloop             bcf             STATUS,C
                        rrf             CMaskByte1,F
                        rrf             CMaskByte2,F
                        decfsz          CRestloop,F
                        Goto            Crechenloop
Crestistnull             
			
			movf		CByteNr,W
			addlw		VideoMEM
			movwf		FSR

			movlw   0x08
			movwf	ISRCOUNT

SPCURSOR		movf	INDF,W
			xorwf	CMaskByte1,W			;invertiert alles in Wregister
			movwf	INDF
			incf	FSR,F
			movf	INDF,W
			xorwf	CMaskByte2,W
			movwf	INDF
			decf	FSR,F
			movlw 	Spaltenbreite
			addwf	FSR,F
			decfsz	ISRCOUNT,F
			goto	SPCURSOR
		return
;*****************************************************************************
;*                  message bei einstieg in den Editmode                     *
;*****************************************************************************
EditMessage             call	cleardisplay
			movlw   0x02
			movwf	sysnr
			call	printSYSMeldung
			call	RunmodeINIT
        Return
;**************************************EDIT MODE der text*********************
Editinit                call    EditMessage
                        clrf    Cursortimer
                        call    cleardisplay
                        movlw   Spaltenbreite           ;Cursor Displaymittig
                        movwf   Cursor                  ;Cursor = pos fuer den Cursor im Videomem
                        bcf     STATUS,C
                        rrf     Cursor,F

                        movf    Cursor,W                ;CursorPos=Charpos
                        movwf   CharPos
                        movwf   HC1                     ;HilfsCursor1 auf Cursor setzen

                        movlw   HCMAX
                        movwf   HC2                     ;HilfsCursor2 auf HCMAX

                        movlw   CharOffsetCountMIN
                        movwf   CharOffsetCount

                        movlw   CharOffsetCountHighMIN
                        movwf   CharOffsetCountH

                        bsf     cursorbit
			bcf	taste
                        goto    printchars

Editmode		btfss	taste
			goto	Editmode
			bcf	taste

ESC_Test                movlw   0x76                    ;teste auf ESC
                        xorwf   KeyCode1,W
			btfsc	STATUS,Z
IT_IS_ESC               goto    ExitEditMode
IS_NOT_ESC              NOP

E0_Test                 btfss   KBE0_Bit
                        Goto    IS_NOT_E0
IT_IS_E0                bcf     KBE0_Bit
                                                        ;Test Ob Pfeiltaste nach links
                        movf    KeyCode1,W
                        xorlw   0x6B
                        btfss   STATUS,Z
                        Goto    IS_NOT_PFLINKS
                                                        ;Test Ob CharOffsetCountH=CharOffsetMin
                        movf    CharOffsetCountH,W
                        sublw   CharOffsetCountHighMIN
                                                        ;Erg <0 -> CHCountH>MIN
                                                        ;<0  ->  Z=0 C=0
                                                        ;=0  ->  Z=1 C=1
                                                        ;>0  ->  Z=0 C=1
                        btfsc   STATUS,Z
                        Goto    ChOFFs_High_IS_MIN

                        btfsc   STATUS,C
                        Goto    EditMode
                        Goto    ChOFFs_High_NOT_MIN

ChOFFs_High_IS_MIN                                      ;Test ob CharOffsC>CharOffsCMIN
                        movf    CharOffsetCount,W       ;ChOffsC->W_Reg
                        sublw   CharOffsetCountMIN      ;ChMIN-ChOffsC -> W_Reg
                                                        ;<0 ChOffsC>MIN Z=0 C=0
                                                        ;=0  Z=1  C=1
                        btfsc   STATUS,C
                        Goto    EditMode
ChOFFs_High_NOT_MIN     decf    CharOffsetCount,W
                        movwf   CharOffsetCount
                        xorlw   0xff
                        btfsc   STATUS,Z
                        decf    CharOffsetCountH,F
                        Goto    HilfsCursorKorektur
IS_NOT_PFLINKS

                                                        ;Test Ob PfeilTaste NAch Rechts
                        movf    KeyCode1,W
                        xorlw   0x74
                        btfss   STATUS,Z
                        Goto    IS_NOT_PFRECHTS

                        movf    CharOffsetCountH,W      ;Erg >0 -> Choffs<MAX
                        sublw   CharOffsetCountHighMAX  ;>0 Z=0 C=1
                                                        ;=0 Z=1 C=1
                        btfsc   STATUS,Z
                        Goto    ChOFFsHIGH_IS_EQUAL

IS_Not_Equal            btfss   STATUS,C
                        Goto    EditMode                ;<0
                        Goto    CHOffs_High_NOT_MAX     ;>0
                                                        ;Test Ob CharOffsetCount < CharOffsetMax
ChOFFsHIGH_IS_EQUAL     movf    CharOffsetCount,W       ;ChOffCount->W_Reg
                        sublw   CharOffsetCountMax      ;ChOffMax-ChOffCount->W_Reg
                                                        ;>=0   Z=0  C=1
                        btfsc   STATUS,Z
                        Goto    EditMode                ;IST Gleich
                        NOP                             ;Nicht_Gleich 
                        btfss   STATUS,C
                        Goto    EditMode                ;<0
CHOffs_High_NOT_MAX     incf    CharOffsetCount,F       ;>0
                        btfsc   STATUS,Z
                        incf    CharOffsetCountH,F
                        Goto    HilfsCursorKorektur
IS_NOT_PFRECHTS
                        movf    KeyCode1,W              ;Test auf POS1 Taste
                        xorlw   0x6C
                        btfss   STATUS,Z
                        Goto    IS_NOT_POS_TASTE
IT_IS_POS_TASTE         movlw   CharOffsetCountMIN
                        movwf   CharOffsetCount
                        movlw   CharOffsetCountHighMIN
                        movwf   CharOffsetCountH
                        Goto    HilfsCursorKorektur
IS_NOT_POS_TASTE
                        movf    KeyCode1,W
                        xorlw   0x69
                        btfss   STATUS,Z
                        Goto    IS_NOT_ENDETASTE
IT_IS_ENDETASTE         movlw   CharOffsetCountMAX
                        movwf   CharOffsetCount
                        movlw   CharOffsetCountHighMAX
                        movwf   CharOffsetCountH
                        Goto    HilfsCursorKorektur
IS_NOT_ENDETASTE
Test_PFEIL_OBEN         movf    KeyCode1,W
                        xorlw   0x75
                        btfss   STATUS,Z
                        Goto    NOT_PFEIL_OBEN
                        movf    CharOffsetCount,W
                        movwf   TEMP
                        movf    CharOffsetCountH,W
                        movwf   TEMPH
PFEIL_OBEN              movlw   CharOffsetCountHighMAX
                        xorwf   CharOffsetCountH,W
                        btfss   STATUS,Z
                        Goto    NOT_AT_MAX
HIGH_ON_MAX             movlw   CharOffsetCountMAX
                        xorwf   CharOffsetCount,W
                        btfss   STATUS,Z
                        Goto    NOT_AT_MAX
HIGH_AND_LOW_AT_MAX     movf    TEMP,W
                        movwf   CharOffsetCount
                        movf    TEMPH,W
                        movwf   CharOffsetCountH
                        Goto    HilfsCursorKorektur

NOT_AT_MAX              incf    CharOffsetCount,F
                        btfsc   STATUS,Z
                        incf    CharOffsetCountH,F
                        call    GetCharOffset
                        movf    CharOffset,W
                        xorlw   0xff
                        btfsc   STATUS,Z
                        Goto    HilfsCursorKorektur
                        Goto    PFEIL_OBEN
NOT_PFEIL_OBEN

Test_Pfeil_Unten        movf    KeyCode1,W
                        xorlw   0x72
                        btfss   STATUS,Z
                        Goto    NOT_Pfeil_Unten
Pfeil_Unten             movf    CharOffsetCount,W
                        movwf   TEMP
                        movf    CharOffsetCountH,W
                        movwf   TEMPH

MARKE32                 movf    CharOffsetCountH,W
                        xorlw   CharOffsetCountHighMIN
                        btfss   STATUS,Z
                        Goto    CHAROFFSHIGH_NOT_MAX
CHAROFFSHIGH_IS_MAX     movf    CharOffsetCount,W       ;CharOffs->W_Reg
                        sublw   CharOffsetCountMIN      ;CHArOFFSMIN-CharOffsCount->W_Reg
                        btfsc   STATUS,C
                        Goto    CHAROFFSET_IS_ON_MIN    ;<0  ->  Z=0 C=0
CHAROFFSHIGH_NOT_MAX    decf    CharOffsetCount,F
                        movf    CharOffsetCount,W
                        xorlw   0xff
                        btfsc   STATUS,Z
                        decf    CharOffsetCountH,F
                        call    GetCharOffset
                        movf    CharOffset,W
                        xorlw   0xff
                        btfsc   STATUS,Z
                        Goto    HilfsCursorKorektur
                        Goto    MARKE32
CHAROFFSET_IS_ON_MIN    movf    TEMP,W
                        movwf   CharOffsetCount
                        movf    TEMPH,W
                        movwf   CharOffsetCountH
NOT_Pfeil_Unten

Test_BILD_UNTEN         movf    KeyCode1,W
                        xorlw   0x7A
                        btfss   STATUS,Z
                        Goto    NOT_BILD_UNTEN
IT_IS_BILD_UNTEN        movf    CharOffsetCountH,W
                        xorlw   CharOffsetCountHighMIN
                        btfss   STATUS,Z
                        Goto    HIGH_NOT_ON_MIN
HIGH_IS_ON_MIN          movlw   CharOffsetCountMIN   ;CharOffsCoMIN->W_Reg
                        addlw   0x0A                 ;+10 ins W_reg
                        subwf   CharOffsetCount,W    ;CharOffsCount - W_Reg
                        btfss   STATUS,C             ;>0  Z=0 C=1
                        Goto    Geht_Nicht_mehr
HIGH_NOT_ON_MIN         movlw   0x0A
                        movwf   TEMP
BILDUNTENLOOP           decf    CharOffsetCount,F
                        movf    CharOffsetCount,W
                        xorlw   0xff
                        btfsc   STATUS,Z
                        decf    CharOffsetCountH,F
                        decfsz  TEMP,F
                        Goto    BILDUNTENLOOP
                        Goto    Hilfscursorkorektur
Geht_Nicht_mehr
NOT_BILD_UNTEN

Test_BILD_OBEN          movf    KeyCode1,W
                        xorlw   0x7D
                        btfss   STATUS,Z
                        Goto    NOT_BILD_OBEN
IST_BILD_OBEN_TASTE     movlw   CharOffsetCountHighMAX
                        xorwf   CharOffsetCountH,W
                        btfss   STATUS,Z
                        Goto    CHARH_NICHT_MAX
CHARH_IST_MAX           movf    CharOffsetCount,W
                        sublw   CharOffsetCountMAX
                        sublw   0x0A            ;<0 OK C=0 ,>0 C=1 geht nicht mehr
                        btfsc   STATUS,C
                        Goto    NOT_BILD_UNTEN
CHARH_NICHT_MAX         movlw   0x0A
                        movwf   TEMP
BILD_OBEN_LOOP          incf    CharOffsetCount,F
                        btfsc   STATUS,Z
                        incf    CharOffsetCountH,F
                        decfsz  TEMP,F
                        Goto    BILD_OBEN_LOOP
                        Goto    Hilfscursorkorektur
NOT_BILD_OBEN
                                                ;Hier pruefen welche E0_taste
                                                ;Wenn es Exended Key ist
                                                ;und keine von den obeigen zutrifft
                                                ;dann gehe zurueck zu editmode
                        Goto    EditMode
IS_NOT_E0

LoeschTaste             movlw   0x66
                        xorwf   KeyCode1,W
                        btfss   STATUS,Z
                        Goto    IS_NOT_LoeschTaste

IT_IS_LoeschTaste       movf    CharOffsetCountH,W
                        sublw   CharOffsetCountHighMIN
                                                        ;Erg <0 -> CHCountH>MIN
                                                        ;<0  ->  Z=0 C=0
                                                        ;=0  ->  Z=1 C=1
                                                        ;>0  ->  Z=0 C=1
                        btfsc   STATUS,Z
                        Goto    CHOff_High_AUF_MIN

                        btfsc   STATUS,C
                        Goto    EditMode
                        Goto    ChOff_High_NOT_AUF_MIN
CHOff_High_AUF_MIN                                      ;Test ob CharOffsC>CharOffsCMIN
                        movf    CharOffsetCount,W       ;ChOffsC->W_Reg
                        sublw   CharOffsetCountMIN      ;ChMIN-ChOffsC -> W_Reg
                                                        ;<0 ChOffsC>MIN Z=0 C=0
                        btfsc   STATUS,C
                        Goto    EditMode
ChOff_High_NOT_AUF_MIN  call    cleardisplay
                        decf    CharOffsetCount,F
                        movf    CharOffsetCount,W
                        xorlw   0xff
                        btfsc   STATUS,Z
                        decf    CharOffsetCountH,F
                        movlw   0x29
                        movwf   FWDATAL
                        call    PutCharOffset
                        Goto    HilfsCursorKorektur
IS_NOT_LoeschTaste      

Taste_Return            movlw   0x5A
                        xorwf   KeyCode1,W
                        btfss   STATUS,Z
                        Goto    IS_NOT_Taste_Return

IT_IS_Taste_Return      movlw   0xff
                        movwf   KeyCode1
IS_NOT_Taste_Return     

Test_IF_Shift_Is_Set    btfss   Shiftbit
                        Goto    Shift_Bit_Not_Set
                        bsf     KeyCode1,7
Shift_Bit_Not_Set

Test_if_valid_key       movf    KeyCode1,W
                        addlw   ZeichensatzL                    ;0x00
                        movwf   ADDRL
                        movlw   ZeichensatzH                    ;0x18
                        movwf   ADDRH
                        call    Flashread                       ;holt den zeichenvektor in dataL und dataH
                        movf    DATAH,W                         ;
                        xorlw   0x3F
                        btfsc   STATUS,Z
Not_A_Valid_Key         Goto    Editmode
IT_IS_A_VALID_KEY       NOP
                        movf    KeyCode1,W
                        movwf   FWDATAL
                        call    PutCharOffset              ;Gueltige Taste Gespeichert

                        movf    CharOffsetCountH,W      ;Erg >0 -> Choffs<MAX
                        sublw   CharOffsetCountHighMAX  ;>0 Z=0 C=1
                                                        ;=0 Z=1 C=1
                        btfsc   STATUS,Z
                        Goto    ChOFFsHIGH_IS_Gleich

IS_Nicht_Equal          btfss   STATUS,C
                        Goto    Raus                    ;<0
                        Goto    CHOffs_High_Nicht_MAX   ;>0
ChOFFsHIGH_IS_Gleich                                    ;Test Ob CharOffsetCount < CharOffsetMax
                        movf    CharOffsetCount,W       ;ChOffCount->W_Reg
                        sublw   CharOffsetCountMax      ;ChOffMax-ChOffCount->W_Reg
                                                        ;>=0   Z=0  C=1
                        btfsc   STATUS,Z
                        Goto    Raus            ;IST Gleich
                        NOP                     ;Nicht_Gleich 
                        btfss   STATUS,C
                        Goto    Raus                    ;<0
Ist_Kleiner

CHOffs_High_Nicht_MAX   incf    CharOffsetCount,F       ;>0
                        btfsc   STATUS,Z
                        incf    CharOffsetCountH,F
HilfsCursorKorektur
                        movlw   HCMIN
                        movwf   HC1
                        movf    CharOffsetCountH,W
                        xorlw   CharOffsetCountHighMIN
                        btfss   STATUS,Z
                        Goto    Raus

                        movlw   HCMIN                   ;CharOffsetCount>(Cursor-HC1)?
                        subwf   Cursor,W                ;Cursor-HCMIN  --> W_reg
                        subwf   CharOffsetCount,W       ;Wenn Ergebn.>0 -->   Z=0  C=1
                                                        ;ChOffsC<W_Reg->Ergebn<0->Z=0 C=0
                        btfsc   STATUS,Z
                        Goto    NochGleich
                        btfsc   STATUS,C
                        Goto    Raus
NochGleich
                        movf    CharOffsetCount,W       ;Setze HC1 auf Cursor-CharOffsetcount
                        subwf   Cursor,W
                        movwf   HC1
                        call    cleardisplay            ;Zeichen loeschen (Provisorisch)
Raus

                        movlw   HCMAX
                        movwf   HC2

                        movf    CharOffsetCountH,W
                        xorlw   CharOffsetCountHighMAX
                        btfss   STATUS,Z
                        goto    Raus2

                                                        ;Solange (HCMAX-Cursor)>(CharOffsMAX-CharOffsCount) Berichtige HC2
                                                        ;HC2 = Cursor+(CharOffsMax-CharOffsCount)
                                                        ;Wenn  (HCMAX-Cursor)-(CHoffsCoMAX-CharOffsCount)

                        movf    Cursor,W                ;Cursor->W_Reg
                        sublw   HCMAX                   ;HCMAX-Cursor -> W_Reg
                        movwf   TEMP
                        movf    CharOffsetCount,W       ;CHarOffCount ->W_Reg
                        sublw   CharOffsetCountMAX      ;(CharOffsMAX-CharOffCount)->W_Reg
                        subwf   TEMP,W                  ;Temp-(...) -> W_Reg
                                                        ;>0  Temp>(...) Z=0 C=1
                                                        ;<0  Temp<(...) Z=0 C=0
                                                        ;=0  Temp=(...) Z=1 C=1
                        btfss   STATUS,C
                        Goto    Raus2
                        movf    CharOffsetCount,W       ;CHarOffCount ->W_Reg
                        sublw   CharOffsetCountMAX      ;(CharOffsCtMAX-CharOffCount)->W_Reg
                        addwf   Cursor,W
                        movwf   HC2
                        call    cleardisplay
Raus2

;gebe die Zeichen aus dem Flashmemory von
;(CharoffsetCount-(Cursor-HC1) bis (CharOffsetCount+HC2-cursor)
;(CharoffsetCount- Cursor+HC1)     (CharOffsetCount+HC2-Cursor)

;An die Stelle auf dem display (Cursor-(Cursor-HC1)) bis (Cursor+(HC2-Cursor))
printchars
                        movf     CharOffsetCount,W
                        movwf    TEMP
                        movf     CharOffsetCountH,W
                        movwf    TEMPH

                        movf    Cursor,W
                        movwf   Counter

marke11                 decf    CharOffsetCount,F
                        movf    CharOffsetCount,W
                        xorlw   0xff
                        btfsc   STATUS,Z
                        decf    CharOffsetCountH,F
                        decfsz  Counter,F
                        Goto    marke11

                        movf    HC1,W
                        btfsc   STATUS,Z
                        Goto    HC1_IST_NULL
                        movwf   Counter
marke12                 incf    CharOffsetCount,F
                        btfsc   STATUS,Z
                        incf    CharOffsetCountH,F
                        decfsz  Counter,F
                        Goto    marke12
HC1_IST_NULL
                        movf     HC1,W
                        movwf    Counter        
                        movwf    CharPos

DMARKE                  call    GetCharOffset
                        call    copytovideomem
                        incf    counter,F
                        movf    Counter,W
                        movwf   CharPos

                        incf    CharOffsetCount,F
                        btfsc   STATUS,Z
                        incf    CharOffsetCountH,F
                        movf    HC2,W
                        xorwf   Counter,W
                        btfss   STATUS,Z
                        goto    DMARKE

                        movf    temp,W
                        movwf   CharOffsetCount
                        movf    TEMPH,W
                        movwf   CharOffsetCountH
Nichtende               goto    Editmode

ExitEditMode            bcf     cursorbit
                        call    GENTXTBLOCKTABELLE
                Return
;*****************************************************************************
;**********                        E N D E   E D I T M O D E                 *
;*****************************************************************************
TextNrEditInit		NOP
                        movlw   0x05           		;Cursor auf Stelle 4
                        movwf   Cursor                  ;Cursor = pos fuer den Cursor im Videomem

                        clrf    TXTFOLGECOUNTER			
			call	GetTextBlockNr
			Goto	PrintTXTNr

TextNrEdit	        call	delay
			btfss	ModusByte,2
			Goto	NOTMODUS2
			btfss	ModusBlinkBit
			Goto	BitNotSet
			bcf	ModusBlinkBit
			movlw	0x00
			movwf	CharPos
			movlw	0x29
			movwf	CharOffset
			call	Copytovideomem
			Goto	NOTMODUS2
BitNotSet		bsf	ModusBlinkBit
			movlw	0x00
			movwf	CharPos
			movf	ModusChar,W
			movwf	CharOffset
			call	Copytovideomem
NOTMODUS2		btfss	Taste
			goto	TextNrEdit
			bcf	Taste
testobgultigeTaste
		        movlw   0x76 
                        xorwf   KeyCode1,W
			btfsc	STATUS,Z
	                goto    ExitTXTEditMode

                        btfss   KBE0_Bit
                        Goto    E0_Bit_NOT_SET
                        bcf     KBE0_Bit

                        movf    KeyCode1,W               ;Test Ob Pfeiltaste nach links
                        xorlw   0x6B
                        btfss   STATUS,Z
                        Goto    NOT_PFLINKS
			movf	TXTFOLGECOUNTER,W
			btfss	STATUS,Z
			decf	TXTFOLGECOUNTER,F
			call	GetTextBlockNr
			Goto	PrintTXTNr
NOT_PFLINKS
                        movf    KeyCode1,W		;Test AUf PfeilTaste_Rechts
                        xorlw   0x74
                        btfss   STATUS,Z
                        Goto    NOT_PFRECHTS

			call	GetTextBlockNr
			movlw	0xFF
			xorwf	TextBlockNr,W
			btfsc	STATUS,Z
			Goto	Zeichen_ist_FF
			movlw	TXTFOLGECOUNTERMAX
			xorwf	TXTFOLGECOUNTER,W
			btfss	STATUS,Z
			incf	TXTFOLGECOUNTER,F
Zeichen_ist_FF		
			call	GetTextBlockNr
			Goto	PrintTXTNr
NOT_PFRECHTS
		        movf    KeyCode1,W		;Test_PFEIL_OBEN 
                        xorlw   0x75
                        btfss   STATUS,Z
                        Goto    NOT_PFOBEN

			decf	TabellenCounter,W
			xorwf	TextBlockNr,W
			btfss	STATUS,Z
			incf	TextBlockNr,F
			call	PutTextBlockNr			
			Goto	PrintTXTNr
NOT_PFOBEN
		        movf    KeyCode1,W		;Test_Pfeil_Unten
                        xorlw   0x72
                        btfss   STATUS,Z
                        Goto    NOT_PFUnten

			movf	TextBLOCKNr,W
			btfss	STATUS,Z
			decf	TextBlockNr,F
			call	PutTextBlockNr			
			Goto	PrintTXTNr
NOT_PFUnten

			Goto	TextNrEdit
E0_Bit_NOT_SET

RetTASTE                movlw   0x5A
                        xorwf   KeyCode1,W
                        btfss   STATUS,Z
                        Goto    NOTRetTASTE

			movlw	0x3F
			movwf	ModusByte
			movlw	0xFF
			movwf	TextBlockNr
			call	PutTextBlockNr
			Goto	PrintTXTNr
NOTRetTASTE

TestPlusTaste		movf	KeyCode1,W		;Zeit erhoehen 
			xorlw	0x79			;im modusbyte
			btfss	Status,Z		;00xxx000
			Goto	NOTPLUSTATSTE
			movf	ModusByte,W
			andlw	B'00111000'
			movwf	Counter
			movlw	B'00000111'			
			andwf	ModusByte,F
			bcf	STATUS,C
			rrf	Counter,F
			rrf	Counter,F
			rrf	Counter,F
			incf	Counter,W
			andlw	B'00000111'
			movwf	Counter
			bcf	STATUS,C
			rlf	Counter,F
			rlf	Counter,F
			rlf	Counter,W
			iorwf	ModusByte,F
			call	PutTextBlockNr
			Goto	PrintTXTNr
NOTPLUSTATSTE

SpaceTASTE		movlw   0x29
                        xorwf   KeyCode1,W
                        btfss   STATUS,Z
                        Goto    NOTSPACETASTE
			movf	Modusbyte,W
			andlw	B'00000111'
			xorlw	0x07
			btfss	STATUS,Z
			Goto 	nicht7
ist7			movf	ModusByte,W
			andlw	B'11111000'
			movwf	ModusByte
			Goto	WeiterIst7
nicht7			incf	ModusByte,F
WeiterIst7		call	PutTextBlockNr
			Goto	PrintTXTNr
NOTSPACETASTE
			Goto	TextNrEdit

PrintTXTNr		call    cleardisplay
			clrf	CharPos
			movlw	0x29			;Space
			movwf	CharOffset

	 		movf	ModusByte,W
			iorlw	0x04			;B'00000100
			andlw	B'00000111'		;???
			xorlw	0x04
			btfss	STATUS,Z
			Goto	MODBYTE_NOT4OR0
MODBYTE4OR0 		movlw	0x12
			movwf	CharOffset
			movwf	ModusChar
			Goto	PRINTSYMBOL
MODBYTE_NOT4OR0		movf	ModusByte,W
			iorlw	0x04
			andlw	B'00000111'
			xorlw	0x05
			btfss	STATUS,Z			
			goto	ModusByteNot5OR1
MODBYTE5OR1		movlw	0x13
			movwf	CharOffset
			movwf	ModusChar
			Goto	PRINTSYMBOL
ModusByteNot5OR1
			movf	ModusByte,W
			iorlw	0x04
			andlw	B'00000111'
			xorlw	0x06
			btfss	STATUS,Z			
			goto	ModusByteNot6OR2
MODBYTE6OR2		movlw	0x17			;<-- SpezialMode2
			movwf	CharOffset
			movwf	ModusChar
			Goto	PRINTSYMBOL
ModusByteNot6OR2

			movf	ModusByte,W
			iorlw	0x04
			andlw	B'00000111'
			xorlw	0x07
			btfss	STATUS,Z			
			goto	ModusByteNot7OR2
MODBYTE7OR2		movlw	0x18			;<-- SpezialMode2
			movwf	CharOffset
			movwf	ModusChar
			Goto	PRINTSYMBOL
ModusByteNot7OR2

PRINTSYMBOL		call	copytovideomem

			movlw	0x02
			movwf	CharPos
			movlw	0x03
			movwf	Counter

			movf	TXTFOLGECOUNTER,W
			btfss	STATUS,Z
			Goto	TXTFOLGENOTZERO

			movlw	0x05
			movwf	CharPos
			movlw	0x02
			movwf	Counter
TXTFOLGENOTZERO
			movf	TXTFOLGECOUNTER,W
			xorlw	TXTFOLGECOUNTERMAX	
			btfss	STATUS,Z
			Goto	TXTFOLGENOTMAX
			movlw	0x02
			movwf	CharPos
			movlw	0x02
			movwf	Counter
TXTFOLGENOTMAX
			movf	TextBlockNr,W
			movwf	TEMPH

			movf	TXTFOLGECOUNTER,W
			movwf	TEMP

			movf	ModusByte,W
			movwf	TEMPM

			movf	TXTFOLGECOUNTER,W
			btfss	STATUS,Z
			decf	TXTFOLGECOUNTER,F	

PrintTXTNrloop		call	GetTextBlockNr

			movlw	0xff
			xorwf	TextBlockNr,W
			btfss	STATUS,Z
			Goto	TextBlocknotFF
			movlw	0xff
			movwf	TXTBlockScanCodeH
			movwf	TXTBlockScanCodeL
			Goto	textblockistFF

TextBlocknotFF		movf	TextBlockNr,W
       			call	Bin2BCD
			call	ConvertinScancode

textblockistFF		movf	TXTBlockScanCodeH,W
			movwf	CharOffset
			call	copytovideomem		;lesemarke

			incf	CharPos,F

			movf	TXTBlockScanCodeL,W
			movwf	CharOffset
			call	copytovideomem

			incf	CharPos,F

			movlw	0x11			;-> Zeichen
			movwf	CharOffset
			call	copytovideomem

			incf	CharPos,F

			incf	TXTFOLGECOUNTER,F

            		decfsz	Counter,F
			Goto	PrintTXTNrloop

			movf	TEMP,W
			movwf	TXTFOLGECOUNTER

			movf	TEMPH,W
			movwf	TextBlockNr

			movf	TEMPM,W
			movwf	ModusByte

			incf	Charpos,F
			movf	ModusByte,W
			andlw	B'00111000'
			movwf	counter
			bcf	STATUS,C
			rlf	counter,F
			swapf	counter,W
			call	Bin2BCD
			call	ConvertinScancode
			movf	TXTBlockScancodeL,W
			movwf	CharOffset
			call	copytovideomem	
			Goto	TextNrEdit
ExitTXTEditMode

                Return


;*****************************************************************************
setclock		clrf	sec_L
			clrf	sec_H
			bcf	T1CON,TMR1ON
			clrf	TMR1L
			clrf	TMR1H
			call	clockprint
			movlw	0x02
			movwf	cursor
			movwf	CharPos
			bsf	cursorbit
			bcf	clockbit

Waitforkey		btfss	TASTE
			goto	Waitforkey
			bcf	Taste

                        movf    KeyCode1,W		;Test AUf PfeilTaste_Rechts
                        xorlw   0x74
                        btfss   STATUS,Z
                        Goto    NOT_RECHTS
			incf	CharPos,F
			incf	Cursor,F
			movlw	0x04
			xorwf	CharPos,W
			btfss	STATUS,Z
			Goto	NOT_4
			incf	CharPos,F
			incf	Cursor,F
NOT_4			movlw	0x07
			xorwf	CharPos,W
			btfss	STATUS,Z
			Goto	NOT_RECHTS
			movlw	0x02
			movwf	Cursor
			movwf	CharPos
NOT_RECHTS

		        movf    KeyCode1,W		;Test_PFEIL_OBEN 
                        xorlw   0x75
                        btfss   STATUS,Z
			Goto    NOT_OBEN

			movlw	0x02
			xorwf	CharPos,W
			btfss	STATUS,Z
			Goto	NOTONPOS2
			incf	std_H,F
			movlw	0x03
			xorwf	std_H,W
			btfsc	STATUS,Z
			clrf	std_H
NOTONPOS2
			movlw	0x03
			xorwf	CharPos,W
			btfss	STATUS,Z
			Goto	NOTONPOS3
			incf	std_L,F
			movlw	0x0A
			xorwf	std_L,W
			btfsc	STATUS,Z
			clrf	std_L
NOTONPOS3
			movlw	0x05
			xorwf	CharPos,W
			btfss	STATUS,Z
			Goto	NOTONPOS5
			incf	min_H,F
			movlw	0x07
			xorwf	min_H,W
			btfsc	STATUS,Z
			clrf	min_H
NOTONPOS5
			movlw	0x06
			xorwf	CharPos,W
			btfss	STATUS,Z
			Goto	NOTONPOS6
			incf	min_L,F
			movlw	0x0A
			xorwf	min_L,W
			btfsc	STATUS,Z
			clrf	min_L
NOTONPOS6
NOT_OBEN
			movlw   0x5A
                        xorwf   KeyCode1,W
                        btfsc   STATUS,Z
                        Goto    endclockset

			movf	CharPos,W
			movwf	ClockCharTemp	
			call	clockprint
			movf	ClockCharTemp,W
			movwf	CharPos
			goto	Waitforkey
endclockset
			bcf	cursorbit
			bsf	T1CON,TMR1ON
		return
;*****************************************************************************
clockprint		movf	CharPos,W
			movwf	ClockCharTemp
			movlw	0x02
			movwf	Charpos
			movf	std_H,W
			movwf	MSD
			movf	std_L,W
			movwf	LSD
			call	ConvertInScancode
			movf	TXTBlockScanCodeH,W
			movwf	CharOffset
			call	copytovideomem

			incf	Charpos,F

			movf	TXTBlockScanCodeL,W
			movwf	CharOffset
			call	copytovideomem

			incf	Charpos,F
			
			movlw	0xC9			;DoppelPunkt
			movwf	CharOffset
			call	copytovideomem
			incf	Charpos,F

			movf	min_H,W
			movwf	MSD
			movf	min_L,W
			movwf	LSD
			call	ConvertInScancode
			movf	TXTBlockScanCodeH,W
			movwf	CharOffset
			call	copytovideomem

			incf	Charpos,F

			movf	TXTBlockScanCodeL,W
			movwf	CharOffset
			call	copytovideomem
			incf	Charpos,F

			movlw	0xC9			;DoppelPunkt
			movwf	CharOffset
			call	copytovideomem
			incf	Charpos,F

			movf	sec_H,W
			movwf	MSD
			movf	sec_L,W
			movwf	LSD
			call	ConvertInScancode
			movf	TXTBlockScanCodeH,W
			movwf	CharOffset
			call	copytovideomem

			incf	Charpos,F

			movf	TXTBlockScanCodeL,W
			movwf	CharOffset
			call	copytovideomem
			movf	ClockCharTemp,W
			movwf	CharPos
		Return
;*******************************************************************
ConvertInScancode       movlw	BCD2ScancodeTABH
			movwf	ADDRH

			movlw	BCD2ScancodeTABL
			addwf	MSD,W
			movwf	ADDRL
			call	Flashread

			movf	DATAL,W
			movwf	TXTBlockScanCodeH

			movlw	BCD2ScancodeTABL
			addwf	LSD,W
			movwf	ADDRL
			call	Flashread

			movf	DATAL,W
			movwf	TXTBlockScanCodeL
                Return
;****************************************************************
BIN2BCD                 clrf    MSD
                        movwf   LSD
gtenth                  movlw   0x0A
                        subwf   LSD,W
                        BTFSS   STATUS,C
                        goto    over
                        movwf   LSD
                        incf    MSD,F
                        goto    gtenth
over            RETLW   0
;*****************************************************************************
PutTextBlockNr		movlw   TXTFOLGETABH
                        movwf   FWADDRH
                        movlw   TXTFOLGETABL
                        addwf   TXTFOLGECOUNTER,W
                        movwf   FWADDRL

			movf	Modusbyte,W
			movwf	FWDATAH

			movf	TextBlockNr,W
			movwf	FWDATAL

			call	Flashwrite
		return
;*****************************************************************************
GetTextBlocknr          
			movlw   TXTFOLGETABH
                        movwf   ADDRH
                        movlw   TXTFOLGETABL
                        addwf   TXTFOLGECOUNTER,W
                        movwf   ADDRL

                        call    Flashread

                        movf    DATAH,W
                        movwf   ModusByte

                        movf    DATAL,W
                        movwf   TextBlockNr

		Return
;******************************************************************************
GetTextBlockADDR        movlw   TXTBLOCKTABH
                        movwf   ADDRH
                        movlw   TXTBLOCKTABL
                        bcf     STATUS,C
                        rlf     TextBlockNr,W
                        movwf   ADDRL
                        call    Flashread
                        movf    DATAL,W
                        movwf   CharOffsetCount
                        incf    ADDRL
                        call    Flashread
                        movf    DATAL,W
                        movwf   CharOffsetCountH
                return
;*****************************************************************************
GENTXTBLOCKTABELLE
                        movlw   CharOffsetCountMIN
                        movwf   CharOffsetCount
                        movlw   CharOffsetCountHighMIN
                        movwf   CharOffsetCountH
                        clrf    TabellenCounter
                        call    STORETABELLENDATA
NEXTTXTBLCKCHECK        movf    TabellenCounter,W
                        xorlw   TXTANZAHLMAX
                        btfsc   STATUS,Z
                        Goto    TABELLENMAXERREICHT
                        movf    CharOffsetCountH,W
                        xorlw   CharOffsetCountHighMAX
                        btfss   STATUS,Z
                        Goto    NICHTAUFMAX
ISTAUFMAX               movf    CharOffsetCount,W       ;CHCOUNT->W_Reg
                        xorlw   CharOffsetCountMAX      ;MAX-CHCOUNT->W_Reg
                        btfsc   STATUS,Z
                        Goto    TEXTSPEICHERENDE

NICHTAUFMAX             call    GetCharOffset
                        movf    CharOffset,W
                        xorlw   0xff
                        btfss   STATUS,Z
                        Goto    ISTNICHTFF
ESISTFF                 incf    TabellenCounter,F
                        incf    CharOffsetCount,F
                        btfsc   STATUS,Z
                        incf    CharOffsetCountH,F
                        call    STORETABELLENDATA

ISTNICHTFF              incf    CharOffsetCount,F
                        btfsc   STATUS,Z
                        incf    CharOffsetCountH,F
                        Goto    NEXTTXTBLCKCHECK
TABELLENMAXERREICHT
TEXTSPEICHERENDE
                Return
;*****************************************************************************
STORETABELLENDATA
                        movlw   TXTBLOCKTABH
                        movwf   FWADDRH
                        clrw
                        bcf     STATUS,C
                        rlf     TabellenCounter,W       ;TabellenCounter*2
                        addlw   TXTBLOCKTABL
                        movwf   FWADDRL
                        movf    CharOffsetCount,W
                        movwf   FWDATAL
                        call    Flashwrite
                        movf    CharOffsetCountH,W
                        movwf   FWDATAL
                        incf    FWADDRL,F
                        call    Flashwrite
                Return

;*****************************************************************************
;*                    Display Loeschen                                       *
;*****************************************************************************
cleardisplay		movlw	VideoMEM
			movwf	FSR
			movlw	0x08
			movwf	loop1
			movlw	Spaltenbreite
			movwf	loop2
loeschen		movlw	0xff
			movwf	INDF
			incf	FSR,F
			decfsz	loop2,F
			goto 	loeschen
			movlw	Spaltenbreite
			movwf	loop2
			decfsz	loop1,F
			goto	loeschen
		return
;*****************************************************************************

INIT                    bsf     STATUS,IRP
                        bcf     STATUS,RP0                      ;
                        bcf     STATUS,RP1                      ;	
			bcf	BlinkEnableBit

			clrf	Cursor
			clrf	FARBE
			
                        CLRF    PORTA
			CLRF	PORTB
                        CLRF    PORTC                           ;
			bsf	Blinkbit			;Output enable EIN
			bsf	STATUS,RP0			;Bank1
                        bcf     OPTION_REG,T0CS                 ;Timer0Clockselect=Fosc/4
			bsf	INTCON,T0IE			;Timer0_Int_Enable
			clrf	TRISA				;Alle auf Output
			MOVLW	B'00000011'			;PORTB0 - Input KeyClock
			MOVWF	TRISB				;PORTB1 - Input KeyData
			clrf	TRISC				;Alle auf Output

			bcf	STATUS,RP0			;Bank0
			movlw	Spaltenbreite			;Zaehler fuer aktuelles
			movwf	Spaltenbyte			;Byte im videomem ISR-reserviert
                        clrf    Devicestatus
                        clrf    Keystatus
			clrf	time1
			clrf	time2
			clrf	time3
			clrf	zeit				;zeit fuer anzeigedauer des text ,bei zentrierter anzeige
			movlw	0x10
			movwf	time_for_nexttext
                        movlw   CharOffsetCountMIN
			movwf	CharOffsetCount
                        movlw   CharOffsetCountHighMIN
                        movwf   CharOffsetCountH
                        clrf    ShiftVelocity
                        bsf     ShiftVelocity,1
;                        call    GENTXTBLOCKTABELLE		;
			call	cleardisplay
			call	ClockINIT
			call	SSPINIT				;Fuer die videoanzeige
			call	PB_INT_INIT			;Fuer das keyboard
			bsf	INTCON,GIE			;Global_INT_Enable
			movlw	0x01
			movwf	sysnr
			call	printSYSMeldung
			call	Flash_it
			bsf	taste
			movlw	0x06		;F2
                        movwf   KeyCode1
			bsf	REDPIN
		return

SSPINIT			bsf	STATUS,RP0			;Bank 1
                        BSF     SSPSTAT,CKE                     ;Clock transmittet on rising Edge - SSPe
			bcf	STATUS,RP0			;Bank 0		
								;---------------SSP Initialisieren
                        bcf     SSPCON,SSPM0     
                        bcf     SSPCON,SSPM1     
			bcf	SSPCON,SSPM2		
			bcf	SSPCON,SSPM3			;MASTER_Mode - Fosc/16
                        BCF     SSPCON,CKP                      ;ClockPolarity = 0
			bsf	SSPCON,SSPEN			;SSP Einschalten
			movlw	VideoMEM				;
			movwf	VideomemFSR_Temp		;FSR-Register auf den Videospeicher setzen 110Hex
								;---------------SSP ist initialisiert
		return
PB_INT_INIT		BSF	STATUS,RP0			;Bank 1
			BCF	OPTION_REG,INTEDG		;Interrupt on falling edge
			BCF	STATUS,RP0			;Bank 0
			BSF	INTCON,INTE			;INT0 enable
                        CLRF    Keybit
		return

ClockINIT               clrf    sec_L
			clrf	sec_H
			clrf	min_L
			clrf	min_H
			clrf	std_L
			clrf	std_H
			bcf	clockbit
			bcf	ClockEnableBit
			bsf	T1CON,T1OSCEN
			bsf	T1CON,T1SYNC
			bsf	T1CON,TMR1CS
			bsf	T1CON,TMR1ON
			bsf	STATUS,RP0
			bsf	PIE1,TMR1IE
			bcf	STATUS,RP0
			
		return
;****************************************************************************
;Holt adressen CharOffsetCount,CharOffsetCountH von systemmeldung Nr. -> sysnr.
;
printSYSMeldung		clrf	loop1		
			movlw	sysH
			movwf	CharOffsetCountH
			movlw	sysL
			movwf	CharOffsetCount
sysmarke1		call	GetCharOffset
			incf	CharOffsetCount,F
			btfsc	STATUS,Z
			incf	CharOffsetCountH,F
			movlw	0xFF
			xorwf	CharOffset,W
			btfss	STATUS,Z
			Goto	sysmarke1
			incf	loop1,F
			movf	sysnr,W
			xorwf	loop1,W
			btfss	STATUS,Z
			Goto	sysmarke1
		return
;*****************************************************************************
main			call	INIT
SPService		
			btfss	taste
			goto	SPService
                        bcf     taste

tastenauswertung        
			movlw   0x05            ;F1
                        xorwf   KeyCode1,W
			btfss	STATUS,Z
			Goto	NOTF1
                        call    Editinit
			call	cleardisplay
NotF1

			movlw	0x06		;F2
                        xorwf   KeyCode1,W
                        btfss   STATUS,Z
                        Goto    NOTF2
			bsf	Devicestatus,4		;Bit fr F2 mode einschalten
                        clrf    TXTFOLGECOUNTER
			bsf	ClockEnableBit
RunModeLoop             call    GetTextBlockNr

			movf	TextBlockNr,W
                        xorlw   0xff
                        btfss   STATUS,Z
                        Goto    KEINFF

ISTEINFF                clrf    TextBlockNr
                        clrf    TXTFOLGECOUNTER
                        call    GetTextBlocknr
KEINFF
			call	GetTextBlockADDR
                        incf    TXTFOLGECOUNTER,F
			bsf	BlinkEnableBit
			movf	ModusByte,W
			andlw	B'00111000'
			movwf	zeit
			bcf	STATUS,C
			rlf	zeit,F
			swapf	zeit,F 
			movf	ModusByte,W
			andlw	B'00000011'	
			btfsc	STATUS,Z
                        call    RunmodeINIT
			bcf	BlinkEnableBit			
			movf	ModusByte,W
			andlw	B'00000011'
			btfss	STATUS,Z
			call	Flashtextinit
			
			movlw	0x76			;ESC
                        xorwf   KeyCode1,W
			btfsc	STATUS,Z
                        goto    EXITF2
	                Goto    RunModeLoop
EXITF2			bcf	Devicestatus,4		;Bit fr F2 mode ausschalten
			bcf	ClockEnableBit
NOTF2			bcf	BlinkEnableBit
			movlw	0x04			;F3
			xorwf	KeyCode1,W
			btfss	STATUS,Z
			Goto	NotF3
			call	cleardisplay
			movlw	0x03
			movwf	sysnr
			call	printSYSMeldung
			call	RunModeInit
			call	TextNrEditInit
NotF3			
			movlw	0x0C			;F4
			xorwf	KeyCode1,W
			btfss	STATUS,Z
			Goto	NOTF4
			call	cleardisplay
			call	clockprint
			call	setclock
NOTF4


			movlw	0x03			;F5
                        xorwf   KeyCode1,W
			btfss	STATUS,Z
			Goto	NOTF5
			incf	FARBE,F
			movlw	0x02
			xorwf	FARBE,W
			btfsc	STATUS,Z
			clrf	FARBE

NOTF5
			call	cleardisplay
			movlw	0x01
			movwf	sysnr
			call	printSYSMeldung
			call	Flash_it
		goto	SPService
;*****************************************************************************
Delay	        btfss	taste
		goto	notaste
		movf    KeyCode1,W
                xorlw   0x76                    		;teste auf ESC   
		btfsc	STATUS,Z
		Return
notaste		
		decfsz	DelayL,F
		Goto	Delay
		decfsz	DelayH,F
		Goto	Delay
	return
;******************************************************************************
Flashtextinit		movf		zeit,w
			movwf		time_for_nexttext
			bcf		STATUS,C
			rlf		time_for_nexttext
			rlf		time_for_nexttext
			bsf		nexttextbit
Flashtextmode		btfsc		NoDelayBit
			Goto		clearnexttextbit
			btfsc		nexttextbit			;test time for nexttext
			goto		clearnexttextbit

			btfss	taste
			Goto	Flashtextmode
			bcf	taste
                        movf    KeyCode1,W
                        xorlw   0x76                    		;teste auf ESC   
			btfsc	STATUS,Z
			Goto	Found_an_FF
			Goto	Flashtextmode

clearnexttextbit	bcf		nexttextbit
			Goto		GO_No_Space
Flash_it		bsf		NoDelayBit	
GO_No_SPACE		call		GetCharOffset

			movlw		0xFF
			xorwf		CharOffset,W
			btfsc		STATUS,Z
			Goto		Found_an_FF

			movlw		0x29
			xorwf		CharOffset,W
			btfss		STATUS,Z
			Goto		No_Space_Found

			incf		CharOffsetCount,F
			btfsc		STATUS,Z
			incf		CharOffsetCountH,F

			goto		GO_No_SPACE
No_Space_Found
			movf		CharOffsetCount,W
			movwf		TEMP
			movf		CharOffsetCountH,W
			movwf		TEMPH
			clrf		flashloop1		;Wenn er beim ersten mal gefunden 
								;dann stehts in loop1 und tempM ist leer
			clrf		TEMPM			;wenn mehrere male gesucht stehts in TempM				
Go_For_Space		incf		CharOffsetCount,F
			btfsc		STATUS,Z
			incf		CharOffsetCountH,F
			incf		flashloop1,F
			call		GetCharOffset

			incf		HC2,F			;

			movlw		0x29			;teste Auf Space
			xorwf		CharOffset,W
			btfsc		STATUS,Z
			Goto		Space_Found

			clrf		HC2

			movlw		0xFF
			xorwf		CharOffset,W
			btfsc		STATUS,Z
			Goto		Print_It

			goto		GO_for_SPACE

Space_Found		movlw		0x03
			xorwf		HC2,W
			btfss		STATUS,Z
			Goto		NOT3Space
			decf		Flashloop1,F
			decf		Flashloop1,F
			decf		Flashloop1,F
			Goto		Print_It
NOT3Space		
			movf		flashloop1,W
			sublw		HCMAX				;hcmax-loop1
			btfss		STATUS,C			;<0   Z=0   C=0
			Goto		Print_It

			movf		flashloop1,W
			movwf		TEMPM

			Goto		Go_For_Space

Print_It		movf		TEMPM,W				;
			btfss		STATUS,Z
			Goto		Passtrein
			
			movf		Flashloop1,W
			sublw		HCMAX		;HCmax-Loop1 -> <0 -> Flashloop1 > HCMAX
			btfss		STATUS,C	;<0 -> C=0
			Goto		Passtnichtinanzeige

			movf		Flashloop1,W
			movwf		TEMPM

Passtrein		movf		TEMPM,W
			sublw		HCMAX
			movwf		HC1
			bcf		STATUS,C
			rrf		HC1,F

			movf		TEMPM,W
			movwf		flashloop1

			Goto		OnDisplay

Passtnichtinanzeige	movlw		HCMIN
			movwf		HC1
			movf		HC1,W
			sublw		HCMAX
			movwf		Flashloop1

OnDisplay		bcf		BlinkEnableBit			;Bim bildaufbau BlinkEnable aus
			call		cleardisplay

			movf		TEMP,W
			movwf		CharOffsetCount
			movf		TEMPH,W
			movwf		CharOffsetCountH

			movf		HC1,W
			movwf		CharPos

nextChar		call            GetCharOffset                   ;Holt den CharOffset von der adresse CharOffsetCount aus dem Textspeicher

			movlw		0xF3
			xorwf		CharOffset,W
			btfss		STATUS,Z
			goto		No_Clock_Symbol
			call		clockprint
			bsf		Clockbit
			bcf		nexttextbit
waitforbitset		btfss		nexttextbit
			Goto		waitforbitset
			bcf		clockbit
			goto		Clockprinted
No_Clock_Symbol
			call            copytovideomem                  ;Copiert die BITMAP mit Charoffset aus den zeichensatz in VideoMEM an die Stelle Cursor
			movf		ModusByte,W			;Wenn Mousbyte=2 dann 
			andlw		B'00000011'			;
			xorlw		0x02				;
			btfsc		STATUS,Z			;
			call		Delay				;Zeitverzgerung
Clockprinted
			incf		CharOffsetCount,F		;Zeiger in den textspeicher
			btfsc		STATUS,Z
			incf		CharOffsetCountH,F
			incf		CharPos,F
			call            GetCharOffset                   ;Holt den CharOffset von der adresse CharOffsetCount aus dem Textspeicher
			decfsz		flashloop1,F
			goto 		nextChar
			clrf		time3
			bcf		nexttextbit
			bsf		BlinkEnableBit
                        goto    	Flashtextmode
Found_an_FF		bcf		BlinkEnableBit
			bcf		NoDelayBit
		return
;*****************************************************************************
copytovirtualmem        movlw           Virtualchar
			addlw		VideoMEM	
			movwf		FSR				;Fsr_register mit videoadresse+Zeichenpos  laden
			movlw		0x08				;8 Weil zeichenhoehe =8
			movwf		copytovirtualloop1
			movf		CharOffset,W			;
			addlw 		ZeichensatzL			;0x00
			movwf		ADDRL
			movlw		ZeichensatzH			;0x18
			movwf		ADDRH
									;Charoffset +1800Hex auf die zeichenveltortabelle
			call		Flashread			;holt den zeichenvektor in dataL und dataH
			movf		DATAL,W				;Vektor fuer zeichenbitmapbyte in adresszeiger laden
			movwf		ADDRL
			movf		DATAH,W
			movwf		ADDRH
SPV			call		Flashread			;Holt ZeichenBitmapByte
			incf		ADDRL,F
			btfsc		STATUS,Z			;teste ob Lowbyte Overflow
			incf		ADDRH,F				;wenn ja dann erhoehe ADDRH
			movf		DATAL,W
			xorlw		0xff
			movwf		INDF
			incf		FSR,F
			decfsz		copytovirtualloop1,F
			goto 		SPV
		return
;****************************************************************************
;*CopyCharBitMaptoVideoMEM an der Position CharPos (Cursor in Byte (zeichen))*
;****************************************************************************
copytovideomem          movf            CharPos,W
                        movwf           ByteNr

			bcf		STATUS,C
			rlf		ByteNr,F		;*2
                        rlf		ByteNr,w		;*4 im W-Reg
                        addwf		ByteNr,W		;+BytrNr*2
                        bcf		STATUS,C		;
                        rrf		ByteNr,F		;+(2*ByteNr/2)
			addwf		ByteNr,F		;->ByteNr
                        clrf		Rest			;***DURCH 8
                        bcf		STATUS,C
                        rrf		ByteNr,F		; /2
                        rrf		Rest,F
                        rrf		ByteNr,F		; /2
                        rrf		Rest,F
			rrf		ByteNr,F		; /2
			rrf		Rest,F			;xxx00000

                        Swapf		Rest,F			;0000xxx0
                        rrf		Rest,F			;00000xxx
                        movlw		VideoMEM
                        addwf           ByteNr,W
			movwf		FSR				;Fsr_register mit videoadresse+Zeichenpos  laden
			movlw		0x08				;8 Weil zeichenhoehe =8
			movwf		copytovideoloop1
                        movf            CharOffset,W                    ;
			addlw 		ZeichensatzL			;0x00
			movwf		ADDRL
			movlw		ZeichensatzH			;0x18
			movwf		ADDRH
                                                                        ;Charoffset +1800Hex auf die zeichenveltortabelle
                        call            Flashread                       ;holt den zeichenvektor in dataL und dataH
			movf		DATAL,W				;Vektor fuer zeichenbitmapbyte in adresszeiger laden
			movwf		ADDRL
			movf		DATAH,W
			movwf		ADDRH
SP1			btfss		DeviceStatus,4
notset			goto		istnichtimF2Mode
bit_is_set		movf		ModusByte,W
			andlw		B'00000011'
			xorlw		0x03
			btfss		STATUS,Z
			goto		istnichtmodus3
			movlw		0x18
			movwf		DelayH
ist_modus3		call		Delay
istnichtimF2Mode
istnichtmodus3		nop
			call		Flashread			;Holt ZeichenBitmapByte
			incf		ADDRL,F
			btfsc		STATUS,Z			;teste ob Lowbyte Overflow
			incf		ADDRH,F				;wenn ja dann erhoehe ADDRH

	                movlw           0x01
                        movwf           MaskByte1
                        movlw           0xFF
                        movwf           MaskByte2
                        clrf            Videobyte2
			movf		DATAL,W
                        xorlw           0xff
                        movwf           Videobyte1
	                movf            Rest,W
			movwf		Restloop
                        btfsc           STATUS,Z
                        goto            restistnull
rechenloop              bcf             STATUS,C
                        rrf             Videobyte1,F
                        rrf             Videobyte2,F
                        bsf             STATUS,C
                        rrf             MaskByte1,F
                        rrf             MaskByte2,F
                        decfsz          Restloop,F
                        Goto            rechenloop
restistnull             movf            INDF,W
                        andwf           MaskByte1,W
                        iorwf           Videobyte1,W
			movwf		INDF
                        incf            FSR,F
                        movf            INDF,W
                        andwf           MaskByte2,W
                        iorwf           Videobyte2,W
                        movwf           INDF
                        decf            FSR,F
			movlw		Spaltenbreite
                        addwf           FSR,F
			decfsz		copytovideoloop1,F
			goto 		SP1
		return
;*****************************************************************************
;*                  Gibt den ZeichenOffset in den  Textspeicher              *
;*****************************************************************************
PutCharOffset           movf            CharOffsetCount,W               ;Position im Textspeicher = CharOffsetCount
			addlw		TextspeicherL
                        movwf           FWADDRL

                        movf            CharOffsetCountH,W
                        addlw           TextspeicherH
                        movwf           FWADDRH
                        call            Flashwrite                       ;Hole Zeichenvektoradresse
		return
;*****************************************************************************
;*                  Holt den ZeichenOffset aus dem Textspeicher              *
;*****************************************************************************
GetCharOffset		movf		CharOffsetCount,W		;Position im Textspeicher = CharOffsetCount
			addlw		TextspeicherL
			movwf		ADDRL

                        movf            CharOffsetCountH,W
                        addlw           TextspeicherH
			movwf		ADDRH

			call		Flashread			;Hole Zeichenvektoradresse
			movf		DATAL,W		
			movwf		CharOffset
		return
;***************************************************************************
;* Liest Data aus dem FlashMemory ADDRL , ADDRH   /   DATAL , DATAH        *
;***************************************************************************
Flashread               bsf     STATUS,RP1
			bcf	STATUS,RP0		;Bank2
			Movf	ADDRL,W
			movwf	EEADR
			movf	ADDRH,W
			movwf	EEADRH
			bsf	STATUS,RP0		;Bank3
                        bsf     EECON1,EEPGD
			bsf	EECON1,RD
			nop
			nop
			bcf	STATUS,RP0		;Bank2
			movf	EEDATA,W
			movwf	DATAL
			movf	EEDATH,W
			movwf	DATAH
			bcf	STATUS,RP1		;Bank0
                Return
;****************************************************************************
;*  Schreibt Data ins FlashMEMORY FWADDRL,FWADDRH / FWDATAL , FWDATAH       *
;****************************************************************************
Flashwrite              BSF     STATUS,RP1
                        BCF     STATUS,RP0              ;Bank2
                        Movf    FWADDRL,W
                        Movwf   EEADR
                        Movf    FWADDRH,W
                        Movwf   EEADRH
                        Movf    FWDATAL,W
                        Movwf   EEDATA
                        Movf    FWDATAH,W
                        Movwf   EEDATH
                        BSF     STATUS,RP0              ;Bank3
                        BSF     EECON1,EEPGD
                        BSF     EECON1,WREN
                        BCF     INTCON,GIE
                        MOVLW   0x55
                        MOVWF   EECON2
                        MOVLW   0xAA
                        MOVWF   EECON2
                        BSF     EECON1,WR
                        NOP
                        NOP
                        BSF     INTCON,GIE
                        BCF     EECON1,WREN
                        BCF     STATUS,RP0
                        BCF     STATUS,RP1
                Return
;****************************************************************************
RunmodeINIT
;			movlw	ShiftVelocityADDRH
;			movwf	ADDRH
;			movlw	ShiftVelocityADDRL
;			movwf	ADDRL
;			call	Flashread
;			movf	DATAL,W
;			movwf	ShiftVelocity

			movf	ModusByte,W
			andlw	B'00111000'
			movwf	ShiftVelocity
			bcf	STATUS,C
			rrf	ShiftVelocity,F
			rrf	ShiftVelocity,F
			rrf	ShiftVelocity,F

			movlw   0x01
                        movwf   RotateCounter
                        movf    ShiftVelocity,W
                        movwf   Shifttimer
                        
Runtextmode             btfss   taste
			goto	keinetaste

                        bcf     taste

			movlw	0x76			;ESC
                        xorwf   KeyCode1,W
			btfsc	STATUS,Z
			goto	ExitRuntextMode

			movlw	0x79			;+ Taste schneller rotieren
                        xorwf   KeyCode1,W
                        btfss   STATUS,Z
                        Goto    PlusTaste_NOT
PlusTaste               clrf    Shifttimer		
			movf	ShiftVelocity,W
			xorlw	0x01
			btfss	STATUS,Z
			decf	ShiftVelocity,F
			movlw	ShiftVelocityADDRH
			movwf	FWADDRH
			movlw	ShiftVelocityADDRL
			movwf	FWADDRL
			clrf	FWDATAH
			movf	ShiftVelocity,W
			movwf	FWDATAL
			call	Flashwrite
PlusTaste_NOT           NOP
			movlw	0x7B			;- Taste langsamer rotieren
                        xorwf   KeyCode1,W
                        btfss   STATUS,Z
                        Goto    MinusTaste_NOT
MinusTaste 		clrf    Shifttimer
			movf	ShiftVelocity,W
			xorlw	0x16
			btfss	STATUS,Z
			incf	ShiftVelocity,F
			movlw	ShiftVelocityADDRH
			movwf	FWADDRH
			movlw	ShiftVelocityADDRL
			movwf	FWADDRL
			clrf	FWDATAH
			movf	ShiftVelocity,W
			movwf	FWDATAL
			call	Flashwrite
MinusTaste_NOT          NOP

keinetaste              movf    ShiftVelocity,W
			xorwf	Shifttimer,W
			btfss	STATUS,Z
			goto	Runtextmode	

Runtextleft             clrf    Shifttimer
                        decfsz  RotateCounter,F
                        goto    nicht7times 
Sieben                  movlw   0x07
                        movwf   RotateCounter
                        call    GetCharOffset
                        movlw   0xff
                        xorwf   CharOffset,W
                        btfsc   STATUS,Z
                        Goto    ExitRuntextMode
charnotFF
                        call    copytovirtualmem
                        incf    CharOffsetCount,F
                        btfsc   STATUS,Z
                        incf    CharOffsetCountH,F
nicht7times
                        movlw   VideoMEM                        ;0x10
                        addlw   Virtualchar                     ;110H+80H = 190h
                        movwf   FSR
                        movlw   0x08                            ;zeichenhoehe
                        movwf   rotateloop2
loadhilfsbyte           rlf     INDF,F                          ;linksschieben bit geht ins Carry
                        rlf     Hilfsbyte,F
                        incf    FSR,F
                        decfsz  rotateloop2,F            
                        goto    loadhilfsbyte
                        movlw   VideoMEM                        ;110 Hex
                        addlw   Spaltenbreite                   ;0x04
                        movwf   FSR                             ;FSR = 114 Hex
                        movlw   0x08                            ;Zeichenhoehe
                        movwf   rotateloop2
                        bcf     INTCON,T0IE

rotate_display          movlw   Spaltenbreite
                        movwf   rotateloop1
                        rlf     Hilfsbyte,F
reihedurch              decf    FSR,F                           ;von 114 hex ausgegangen
                        rlf     INDF,F
                        decfsz  rotateloop1,F
                        goto    reihedurch
                        movlw   Spaltenbreite
                        addwf   FSR,F
                        addwf   FSR,F
                        decfsz  rotateloop2,F
                        goto    rotate_display
                        clrf    Shifttimer
                        bsf     INTCON,T0IE
                        goto    Runtextmode
ExitRuntextMode		bcf	taste
		return
;*****************************************************************************
Keydisplay              movlw   VideoMEM
			movwf	FSR
                        movf    ModusByte,W
                        xorlw   0xff
			movwf	INDF

			movf	FSR,W
			addlw	Spaltenbreite
			movwf	FSR
                        movf    zeit,W
                        xorlw   0xff
			movwf	INDF

			movf	FSR,W
			addlw	Spaltenbreite
			movwf	FSR
                        movf    Devicestatus,W
                        xorlw   0xff
			movwf	INDF
                        
			movf	FSR,W
			addlw	Spaltenbreite
			movwf	FSR
                        movf	Scancode,W
                        xorlw   0xff
			movwf	INDF

			movf	FSR,W
			addlw	Spaltenbreite
			movwf	FSR
                        movf    CharOffsetCount,W
                        xorlw   0xff
			movwf	INDF

                        movf    FSR,W
			addlw	Spaltenbreite
			movwf	FSR
                        movf    CharOffsetCountH,W
                        xorlw   0xff
			movwf	INDF

			movf	FSR,W
			addlw	Spaltenbreite
			movwf	FSR
                        movf    TEMP,W
                        xorlw   0xff
			movwf	INDF

			movf	FSR,W
			addlw	Spaltenbreite
			movwf	FSR
                        movf    CharPos,W
                        xorlw   0xff
			movwf	INDF
                 return
;*****************************************************************************
Powerdown	nop
		goto	Powerdown

;ScanCodeTabelle Zum Konvertieren von Waerten in Scancodes

        org     1500H
	DW	0x0045		; Wert 	0
	DW	0x0016		; Wert 	1
	DW	0x001E		; Wert 	2
	DW	0x0026		;	3
	DW	0x0025		;	4
	DW	0x002E		;	5
	DW	0x0036		;	6
	DW	0x003D		;	7
	DW	0x003E		;	8
	DW	0x0046		;	9


; 0x100 - Hier wird vom programm eine tabelle erstellt
; die tabelle gibt die adressen zu den TextBlockNummern 
; zB. 0x0100 -> 00 Low_Byte   <-TXTBLCKNr.0 -> 0x0800
;     0x0101 -> 08 HighByte
;     0x0102 -> 56 Low_Byte   <-TXTBLCKNr.1 -> 0x0956
;     0x0103 -> 09 HighByte	
;     0x0104 -> XL Low_Byte   <-TXTBLCKNr.2 -> 0xXHXL usw.


;TextNr - Tabelle ( gibt die Reihenfolge der Texte an
;                                       und den Anzeige Modus
        org     0180H
        DW      0000
        DW      0100
        DW      0000
        DW      0100
        DW      0000
        DW      0000
        DW      3FFF

        org     0200H   ;Textspeicher (Offeset zeigt die Vektoradresse des zeichens an)

	DW	0x1B	;s
	DW	0x1A	;y
	DW	0x1B	;s
	DW	0x2C	;t
	DW	0x24	;e
	DW	0x3A	;m
	DW	0x29	;space
	DW	0x2D	;r
	DW	0x24	;e
	DW	0x1C	;a
	DW	0x23	;d
	DW	0x1A	;y
	DW	0x29	;space
	DW	0x29	;space
	DW	0x21	;c
	DW	0x44	;o
	DW	0x4D	;p
	DW	0x1A	;y
	DW	0x2D	;r
	DW	0x43	;i
	DW	0x34	;g
	DW	0x33	;h
	DW	0x2C	;t
	DW	0x29	;space
	DW	0x34	;g
	DW	0x1C	;a
	DW	0x24	;e
	DW	0x2C	;t
	DW	0x1C	;a
	DW	0x31	;n
	DW	0x44	;o
	DW	0x29	;space
	DW	0x23	;d
	DW	0x43	;i
	DW	0x24	;e
	DW	0x1B	;s
	DW	0x24	;e
	DW	0x29	;space
	DW	0x1C	;a
	DW	0x31	;n
	DW	0x35	;z
	DW	0x24	;e
	DW	0x43	;i
	DW	0x34	;g
	DW	0x24	;e
	DW	0x29	;space
	DW	0x43	;i
	DW	0x1B	;s
	DW	0x2C	;t
	DW	0x29	;space
	DW	0x35	;z
	DW	0x3C	;u
	DW	0x29	;space
	DW	0x2A	;v
	DW	0x24	;e
	DW	0x2D	;r
	DW	0x42	;k
	DW	0x1C	;a
	DW	0x3C	;u
	DW	0x2B	;f
	DW	0x24	;e
	DW	0x31	;n
	DW	0x29	;space
	DW	0x29	;space
	DW	0x29	;space
	DW	0x25	;4
	DW	0x45	;0
	DW	0x45	;0
	DW	0x29	;space
	DW	0x29	;space
	DW	0x24	;E
	DW	0x3C	;u
	DW	0x2D	;r
	DW	0x44	;o
	DW	0x29	;space
	DW	0x29	;space
	DW	0x29	;space
	DW	0x29	;space
	DW	0x29	;space
	DW	0x29	;space
	DW	0xff	;reset
	DW	0xff
	DW	0xff
	DW	0xff

        org     0x0254
        fill    0x0029,0x0BAB   ;0254+0dab=0fff

;       vectorTabelle auf die jeweiligen zeichenbitmaps
        ORG     0x1000

        ORG     0x101C
        DW              0x1100                  ;A
        ORG     0x1032
        DW              0x1108                  ;B
        ORG     0x1021
        DW              0x1110                  ;C
        ORG     0x1023
        DW              0x1118                  ;D
        ORG     0x1024
        DW              0x1120                  ;E
        ORG     0x102B
        DW              0x1128                  ;F
        ORG     0x1034
        DW              0x1130                  ;G
        ORG     0x1033
        DW              0x1138                  ;H
        ORG     0x1043
        DW              0x1140                  ;I
        ORG     0x103B
        DW              0x1148                  ;J
        ORG     0x1042
        DW              0x1150                  ;K
        ORG     0x104B
        DW              0x1158                  ;L
        ORG     0x103A
        DW              0x1160                  ;M
        ORG     0x1031
        DW              0x1168                  ;N
        ORG     0x1044
        DW              0x1170                  ;O
        ORG     0x104D
        DW              0x1178                  ;P
        ORG     0x1015
        DW              0x1180                  ;Q
        ORG     0x102D
        DW              0x1188                  ;R
        ORG     0x101B
        DW              0x1190                  ;S
        ORG     0x102C
        DW              0x1198                  ;T
        ORG     0x103C
        DW              0x11A0                  ;U
        ORG     0x102A
        DW              0x11A8                  ;V
        ORG     0x101D
        DW              0x11B0                  ;W
        ORG     0x1022
        DW              0x11B8                  ;X
        ORG     0x101A
        DW              0x11C0                  ;Y
        ORG     0x1035
        DW              0x11C8                  ;Z
        ORG     0x1029
        DW              0x11D0                  ;Space
        ORG     0x1045
        DW              0x11E0                  ;0
        ORG     0x1070
        DW              0x11E0                  ;0      Ziffernblock
        ORG     0x1016
        DW              0x11E8                  ;1
        ORG     0x1069
        DW              0x11E8                  ;1      Ziffernblock
        ORG     0x101E
        DW              0x11F0                  ;2
        ORG     0x1072
        DW              0x11F0                  ;2      Ziffernblock
        ORG     0x1026
        DW              0x11F8                  ;3
        ORG     0x107A
        DW              0x11F8                  ;3      Ziffernblock
        ORG     0x1025
        DW              0x1200                  ;4
        ORG     0x106B
        DW              0x1200                  ;4      Ziffernblock
        ORG     0x102E
        DW              0x1208                  ;5
        ORG     0x1073
        DW              0x1208                  ;5      Ziffernblock
        ORG     0x1036
        DW              0x1210                  ;6
        ORG     0x1074
        DW              0x1210                  ;6      Ziffernblock
        ORG     0x103D
        DW              0x1218                  ;7
        ORG     0x106C
        DW              0x1218                  ;7      Ziffernblock
        ORG     0x103E
        DW              0x1220                  ;8
        ORG     0x1075
        DW              0x1220                  ;8      Ziffernblock
        ORG     0x1046
        DW              0x1228                  ;9
        ORG     0x107D
        DW              0x1228                  ;9      Ziffernblock
        ORG     0x105B
        DW              0x1230                  ;+
        ORG     0x104A
        DW              0x1238                  ;- 
        ORG     0x104C                          
        DW              0x1240                  ;T
        ORG     0x1054
        DW              0x1248                  ;s
        ORG     0x1052
        DW              0x1250                  ;?
        ORG     0x10FF
        DW              0x1258                  ;ReturnZeichen(FF)
        ORG     0x1049
        DW              0x1260                  ; .
        ORG     0x1041
        DW              0x1268                  ; ,
        ORG     0x1061
        DW              0x1270                  ; <
        ORG     0x105D
        DW              0x1278                  ; #
        ORG     0x100E
        DW              0x1280                  ; ^
        ORG     0x1055
        DW              0x1288                  ;
        ORG     0x104E
        DW              0x1290                  ;

;***************Tasten mit Shift******************************

        ORG     0x1096
        DW              0x1298                  ;!
        ORG     0x109E
        DW              0x12A0                  ;"
        ORG     0x10A6
        DW              0x12A8                  ;
        ORG     0x10A5
        DW              0x12B0                  ;$
        ORG     0x10AE
        DW              0x12B8                  ;%
        ORG     0x10B6
        DW              0x12C0                  ;&
        ORG     0x10BD
        DW              0x12C8                  ;/
        ORG     0x10BE
        DW              0x12D0                  ;(
        ORG     0x10C6
        DW              0x12D8                  ;)
        ORG     0x10C5
        DW              0x12E0                  ;=
        ORG     0x10CE
        DW              0x12E8                  ;?
        ORG     0x10D5
        DW              0x12F0                  ;`
        ORG     0x10DB
        DW              0x12F8                  ;*
        ORG     0x10DD
        DW              0x1300                  ;'
        ORG     0x10CA
        DW              0x1308                  ;_
        ORG     0x10C9
        DW              0x1310                  ;:
        ORG     0x10C1
        DW              0x1318                  ;;
        ORG     0x10E1
        DW              0x1320                  ;>
        ORG     0x10EB
        DW              0x11D8                  ;EuroZeichen
        ORG     0x108E
        DW              0x1328                  ;
        ORG     0x1011                   
        DW              0x1330                  ;SpecialPfeil
        ORG     0x1012
        DW              0x1338                  ;RunModeSymbol
        ORG     0x1013
        DW              0x1340                  ;FlashTextSymbol
        ORG     0x10E9                   
        DW              0x1348                  ;@
        ORG     0x10F2                   
        DW              0x1350                  ;Telefonzeichen
        ORG     0x10FA
        DW              0x1358                  ;Copyrightzeichen
        ORG     0x109C                   
        DW              0x1360                  ;a
        ORG     0x10B2
        DW              0x1368                  ;b
        ORG     0x10A1
        DW              0x1370                  ;c
        ORG     0x10A3
        DW              0x1378                  ;d
        ORG     0x10A4
        DW              0x1380                  ;e
        ORG     0x10AB
        DW              0x1388                  ;f
        ORG     0x10B4
        DW              0x1390                  ;g
        ORG     0x10B3
        DW              0x1398                  ;h
        ORG     0x10C3
        DW              0x13A0                  ;i
        ORG     0x10BB
        DW              0x13A8                  ;j
        ORG     0x10C2
        DW              0x13B0                  ;k
        ORG     0x10CB
        DW              0x13B8                  ;l
        ORG     0x10BA
        DW              0x13C0                  ;m
        ORG     0x10B1
        DW              0x13C8                  ;n
        ORG     0x10C4
        DW              0x13D0                  ;o
        ORG     0x10CD
        DW              0x13D8                  ;p
        ORG     0x1095
        DW              0x13E0                  ;q
        ORG     0x10AD
        DW              0x13E8                  ;r
        ORG     0x109B
        DW              0x13F0                  ;s
        ORG     0x10AC
        DW              0x13F8                  ;t
        ORG     0x10BC
        DW              0x1400                  ;u
        ORG     0x10AA
        DW              0x1408                  ;v
        ORG     0x109D
        DW              0x1410                  ;w
        ORG     0x10A2
        DW              0x1418                  ;x
        ORG     0x109A
        DW              0x1420                  ;y
        ORG     0x10B5
        DW              0x1428                  ;z
        ORG     0x10F3
        DW              0x1430                  ;clock_symbol
	ORG	0x1017
	DW		0x1438
	ORG	0x1018
	DW		0x1440
        ORG     0x10F4
        ORG             0x1448                  ;Inverses Leerzeichen

        org     1100H                   ;       Zeichensatz ab 1900 HEX
;					A	0x1100
        DW      B'00000000'      
        DW      B'00010000'
        DW      B'00101000'
        DW      B'01000100'
        DW      B'01111100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
;					B	0x1108
        DW      B'00000000'
        DW      B'01111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01111000'
;					C	0x1110
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01000100'
        DW      B'00111000'
;					D	0x1118
        DW      B'00000000'
        DW      B'01110000'
        DW      B'01001000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01001000'
        DW      B'01110000'
;					E	0x1120
        DW      B'00000000'
        DW      B'01111100'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01110000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01111100'
;					F	0x1128
        DW      B'00000000'
        DW      B'01111100'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01110000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01000000'
;                                       G       0x1130
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01000000'
        DW      B'01011100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111000'
;					H	0x1138
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01111100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
;					I	0x1140
        DW      B'00000000'
        DW      B'01111100'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000' 
        DW      B'01111100'
;					J	0x1148
        DW      B'00000000'
        DW      B'00000100'
        DW      B'00000100'
        DW      B'00000100'
        DW      B'00000100'
        DW      B'01000100'
        DW      B'00101000'
        DW      B'00010000'
;                                       K       0x1150
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01001000'
        DW      B'01010000'
        DW      B'01100000'
        DW      B'01010000'
        DW      B'01001000'
        DW      B'01000100'
;					L	0x1158
        DW      B'00000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01111100'
;					M	0x1160
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01101100'
        DW      B'01010100'
        DW      B'01010100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
;					N	0x1168
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01100100'
        DW      B'01010100'
        DW      B'01001100'
        DW      B'01000100'
        DW      B'01000100'
;					O	0x1170
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111000'
;                                       P       0x1178
        DW      B'00000000'
        DW      B'01111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01111000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01000000'
;					Q	0x1180
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01010100'
        DW      B'00111000'
        DW      B'00000100'
;					R	0x1188
        DW      B'00000000'
        DW      B'01111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01111000'
        DW      B'01010000'
        DW      B'01001000'
        DW      B'01000100'
;					S	0x1190
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01000000'
        DW      B'00111000'
        DW      B'00000100'
        DW      B'01000100'
        DW      B'00111000'
;					T	0x1198
        DW      B'00000000'
        DW      B'01111100'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
;					U	0x11A0
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111000'
;					V	0x11A8
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00101000'
        DW      B'00101000'
        DW      B'00010000'
        DW      B'00010000'
;                                       W       0x11B0
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01010100'
        DW      B'01010100'
        DW      B'01010100'
        DW      B'00101000'
;					X	0x11B8
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00101000'
        DW      B'00010000'
        DW      B'00101000'
        DW      B'01000100'
        DW      B'01000100'
;					Y	0x11C0
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00101000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
;					Z	0x11C8
        DW      B'00000000'
        DW      B'01111100'
        DW      B'00000100'
        DW      B'00001000'
        DW      B'00010000'
        DW      B'00100000'
        DW      B'01000000'
        DW      B'01111100'
;					Space	0x11D0
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
;					Euro	0x11D8	
        DW      B'00000000'
        DW      B'00011100'
        DW      B'00100000'
        DW      B'11111000'
        DW      B'01000000'
        DW      B'11111000'
        DW      B'00100000'
        DW      B'00011100'
;					0	0x11E0
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01001100'
        DW      B'01010100'
        DW      B'01100100'
        DW      B'01000100'
        DW      B'00111000'
;					1	0x11E8
        DW      B'00000000'
        DW      B'00011000'
        DW      B'00101000'
        DW      B'00001000'
        DW      B'00001000'
        DW      B'00001000'
        DW      B'00001000'
        DW      B'00011100'
;					2	0x11F0
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'00001000'
        DW      B'00010000'
        DW      B'00100000'
        DW      B'01000000'
        DW      B'01111100'
;					3	0x11F8
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'00000100'
        DW      B'00111000'
        DW      B'00000100'
        DW      B'01000100'
        DW      B'00111000'
;					4	0x1200  ab 1200h
        DW      B'00000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01001000'
        DW      B'01001000'
        DW      B'01111100'
        DW      B'00001000'
        DW      B'00001000'
;                                       5       1208
        DW      B'00000000'
        DW      B'01111100'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01111000'
        DW      B'00000100'
        DW      B'00000100'
        DW      B'01111000'
;					6	1210
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01000000'
        DW      B'01111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111000'
;					7	1218
        DW      B'00000000'
        DW      B'01111100'
        DW      B'01000100'
        DW      B'00000100'
        DW      B'00001000'
        DW      B'00010000'
        DW      B'00100000'
        DW      B'01000000'
;					8	1220
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111000'
;					9	1228
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111100'
        DW      B'00000100'
        DW      B'01000100'
        DW      B'00111000'
;					+	1230
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'01111100'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00000000'
;					-	1238
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'01111100'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
;                                       "       1240
        DW      B'00101000'
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111000'
;                                       ?       1248
        DW      B'01000100'
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111000'
;                                       ?       1250
        DW      B'01000100'
        DW      B'00010000'
        DW      B'00101000'
        DW      B'01000100'
        DW      B'01111100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
;                                   return      1258
        DW      B'00000000'
        DW      B'01111100'
        DW      B'00000100'
        DW      B'00010100'
        DW      B'00100100'
        DW      B'01111100'
        DW      B'00100000'
        DW      B'00010000'
;                                       .       1260
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00110000'
        DW      B'00110000'
;                                       ,       1268
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00011000'
        DW      B'00011000'
        DW      B'00010000'
        DW      B'00100000'
;                                       <       1270
        DW      B'00000000'
        DW      B'00001000'
        DW      B'00010000'
        DW      B'00100000'
        DW      B'01000000'
        DW      B'00100000'
        DW      B'00010000'
        DW      B'00001000'
;                                       #       1278
        DW      B'00000000'
        DW      B'00101000'
        DW      B'00101000'
        DW      B'11111110'
        DW      B'00101000'
        DW      B'11111110'
        DW      B'00101000'
        DW      B'00101000'
;                                       ^       1280
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00110000'
        DW      B'01001000'
        DW      B'10000100'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
;                                              1288
        DW      B'00001000'
        DW      B'00010000'
        DW      B'00100000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
;                                     	         1290
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01111000'
        DW      B'01000000'
        DW      B'01000000'
                         
;                                       !       1298
        DW      B'00000000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00000000'
        DW      B'00010000'

;                                       "       12A0
        DW      B'00100100'
        DW      B'00100100'
        DW      B'00100100'
        DW      B'01001000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
                         
;                                              12A8
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'00110000'
        DW      B'01001000'
        DW      B'00110000'
        DW      B'10001000'
        DW      B'01110000'
;                                       $       12B0
        DW      B'00010000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'00100000'
        DW      B'00011000'
        DW      B'01000100'
        DW      B'00111000'
        DW      B'00010000'
;                                       %       12B8
        DW      B'00000000'
        DW      B'00110010'
        DW      B'00110100'
        DW      B'00001000'
        DW      B'00010000'
        DW      B'00101100'
        DW      B'01001100'
        DW      B'00000000'

;                                       &       12C0
        DW      B'00000000'
        DW      B'00110000'
        DW      B'01001000'
        DW      B'00110000'
        DW      B'01001010'
        DW      B'10000100'
        DW      B'01001100'
        DW      B'00110010'
;                                       /       12C8
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000100'
        DW      B'00001000'
        DW      B'00010000'
        DW      B'00100000'
        DW      B'01000000'
        DW      B'00000000'
;                                       (       12D0
        DW      B'00010000'
        DW      B'00100000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'00100000'
        DW      B'00010000'
;                                       )       12D8
        DW      B'00100000'
        DW      B'00010000'
        DW      B'00001000'
        DW      B'00001000'
        DW      B'00001000'
        DW      B'00001000'
        DW      B'00010000'
        DW      B'00100000'
;                                       =       12E0
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'01111100'
        DW      B'00000000'
        DW      B'01111100'
        DW      B'00000000'
        DW      B'00000000'

;                                       ?       12E8
        DW      B'00111000'
        DW      B'01000100'
        DW      B'00000100'
        DW      B'00001000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00000000'
        DW      B'00010000'

;                                       `       12F0
        DW      B'00100000'
        DW      B'00010000'
        DW      B'00001000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
;                                       *       12F8
        DW      B'00000000'
        DW      B'10010010'
        DW      B'01010100'
        DW      B'00111000'
        DW      B'11111110'
        DW      B'00111000'
        DW      B'01010100'
        DW      B'10010010'
;                                       '       1300
        DW      B'00001100'
        DW      B'00001100'
        DW      B'00010000'
        DW      B'00100000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
;                                       _       1308
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'11111110'
;                                       :       1310
        DW      B'00000000'
        DW      B'00110000'
        DW      B'00110000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00110000'
        DW      B'00110000'
        DW      B'00000000'
;                                       ;       1318
        DW      B'00000000'
        DW      B'00011000'
        DW      B'00011000'
        DW      B'00000000'
        DW      B'00011000'
        DW      B'00011000'
        DW      B'00010000'
        DW      B'00100000'
;                                       >       1320
        DW      B'00000000'
        DW      B'00100000'
        DW      B'00010000'
        DW      B'00001000'
        DW      B'00000100'
        DW      B'00001000'
        DW      B'00010000'
        DW      B'00100000'
;                                              1328
        DW      B'00011000'
        DW      B'00100100'
        DW      B'00100100'
        DW      B'00011000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
;                                       ->      1330
        DW      B'00000000'
        DW      B'00010000'
        DW      B'00001000'
        DW      B'00001100'
        DW      B'11111110'
        DW      B'00001100'
        DW      B'00001000'
        DW      B'00010000'
;                                       ->      1338	RunModeSymbol

        DW      B'10000000'
        DW      B'11000000'
        DW      B'11111110'
        DW      B'11000010'
        DW      B'10000110'
        DW      B'11111110'
        DW      B'00000110'
        DW      B'00000010'
;                                       ->       1340	FlashTextSymbol
        DW      B'11111110'
        DW      B'10000010'
        DW      B'10111010'
        DW      B'10010010'
        DW      B'10010010'
        DW      B'10010010'
        DW      B'10000010'
        DW      B'11111110'
;                                       ->       1348	@
        DW      B'00000000'
        DW      B'01111100'
        DW      B'10000010'
        DW      B'10011110'
        DW      B'10100010'
        DW      B'10011110'
        DW      B'10000000'
        DW      B'01111110'
;						 1350	Telefonzeichen
        DW      B'00111000'
        DW      B'01111000'
        DW      B'01111000'
        DW      B'01100000'
        DW      B'01100000'
        DW      B'01111000'
        DW      B'01111000'
        DW      B'00111000'
;						 1358	CopyrightZeichen
        DW      B'01111100'
        DW      B'10000010'
        DW      B'10011010'
        DW      B'10100010'
        DW      B'10100010'
        DW      B'10011010'
        DW      B'10000010'
        DW      B'01111100'
;						 1360	a
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00111000'
        DW      B'00000100'
        DW      B'00111100'
        DW      B'01000100'
        DW      B'00111010'
;						 1368	b
        DW      B'00000000'
        DW      B'00100000'
        DW      B'00100000'
        DW      B'00100000'
        DW      B'00111100'
        DW      B'00100010'
        DW      B'00100010'
        DW      B'00111100'
;						 1370	c
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00111100'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'00111100'
;						 1378	d
        DW      B'00000000'
        DW      B'00000100'
        DW      B'00000100'
        DW      B'00000100'
        DW      B'00111100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111010'
;						 1380	e
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01111100'
        DW      B'01000000'
        DW      B'00111000'
;						1388	f
        DW      B'00000000'
        DW      B'00001100'
        DW      B'00010010'
        DW      B'00010000'
        DW      B'00111000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
;						1390	g
        DW      B'00000000'
        DW      B'00111010'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111100'
        DW      B'00000100'
        DW      B'01000100'
        DW      B'00111000'
;						1398	h
        DW      B'00000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01011000'
        DW      B'01100100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
;						13A0	i
        DW      B'00000000'
        DW      B'00010000'
        DW      B'00000000'
        DW      B'00110000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'01111100'
;						13A8	j
        DW      B'00000000'
        DW      B'00000100'
        DW      B'00000000'
        DW      B'00001100'
        DW      B'00000100'
        DW      B'00000100'
        DW      B'01000100'
        DW      B'00111000'
;						13B0	k
        DW      B'00000000'
        DW      B'01000000'
        DW      B'01000000'
        DW      B'01001000'
        DW      B'01010000'
        DW      B'01100000'
        DW      B'01010000'
        DW      B'01001000'
;						13B8	l
        DW      B'00000000'
        DW      B'01110000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'01111100'
;						13C0	m
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00101000'
        DW      B'01010100'
        DW      B'01010100'
        DW      B'01010100'
        DW      B'01010100'
;						13C8	n
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'01011000'
        DW      B'01100100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
;						13D0	o
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00111000'
;						13D8	p
        DW      B'00000000'
        DW      B'01011000'
        DW      B'00100100'
        DW      B'00100100'
        DW      B'00111000'
        DW      B'00100000'
        DW      B'00100000'
        DW      B'01110000'
;						13E0	q
        DW      B'00000000'
        DW      B'00110100'
        DW      B'01001000'
        DW      B'01001000'
        DW      B'00111000'
        DW      B'00001000'
        DW      B'00001000'
        DW      B'00011100'
;						13E8	r
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'01011000'
        DW      B'00100100'
        DW      B'00100000'
        DW      B'00100000'
        DW      B'01110000'
;						13F0	s
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000000'
        DW      B'00111000'
        DW      B'00000100'
        DW      B'00111000'
;						13F8	t
        DW      B'00000000'
        DW      B'00100000'
        DW      B'00100000'
        DW      B'01111000'
        DW      B'00100000'
        DW      B'00100000'
        DW      B'00100100'
        DW      B'00011000'
;						1400	u
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'01001000'
        DW      B'01001000'
        DW      B'01001000'
        DW      B'01001000'
        DW      B'00110100'
;						1408	v
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'00101000'
        DW      B'00101000'
        DW      B'00010000'
;						1410	w
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'01000100'
        DW      B'01000100'
        DW      B'01010100'
        DW      B'01010100'
        DW      B'00101000'
;						1418	x
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'01000100'
        DW      B'00101000'
        DW      B'00010000'
        DW      B'00101000'
        DW      B'01000100'
;						1420	y
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00100100'
        DW      B'00100100'
        DW      B'00011000'
        DW      B'00001000'
        DW      B'00110000'
;						1428	z
        DW      B'00000000'
        DW      B'00000000'
        DW      B'00000000'
        DW      B'01111100'
        DW      B'00001000'
        DW      B'00010000'
        DW      B'00100000'
        DW      B'01111100'
;						1430	Clock_Symbol
        DW      B'00000000'
        DW      B'00111000'
        DW      B'01000100'
        DW      B'10010010'
        DW      B'10011010'
        DW      B'10000010'
        DW      B'01000100'
        DW      B'00111000'

;						1438	;MODE1
        DW      B'00000000'
        DW      B'10000000'
        DW      B'10010000'
        DW      B'10001000'
        DW      B'11111110'
        DW      B'10001000'
        DW      B'10010000'
        DW      B'10000000'
;						1440	;MODE2
        DW      B'00000000'
        DW      B'11111110'
        DW      B'00010000'
        DW      B'00010000'
        DW      B'10010010'
        DW      B'01010100'
        DW      B'00111000'
        DW      B'00010000'
;                                               1448    ;Inverses SpaceZeichen
        DW      B'11111110'
        DW      B'11111110'
        DW      B'11111110'
        DW      B'11111110'
        DW      B'11111110'
        DW      B'11111110'
        DW      B'11111110'
        DW      B'11111110'



;Systemmeldungen
        org     0E00H
	DW	0xFF	;Return
	DW	0x34	;g		;Meldung Nr 1
	DW	0x1B	;s
	DW	0x4A	;-
	DW	0x16	;1
	DW	0x45	;0
	DW	0x45	;0
	DW	0x45	;0
	DW	0xFF	;Return
	DW	0x24	;E	;Meldung Nr 2
	DW	0x23	;D
	DW	0x43	;I
	DW	0x2C	;T
	DW	0x4A	;-
	DW	0x3A	;M
	DW	0x44	;O
	DW	0x23	;D
	DW	0x24	;E
	DW	0x29	;Space	
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0xFF	;Return		;Medung Nr 3
	DW	0x2C	;T	;	textorder
	DW	0x24	;E	;
	DW	0x22	;X	;
	DW	0x2C	;T	;
	DW	0x2D	;R	;
	DW	0x24	;E	;
	DW	0x43	;I	;
	DW	0x33	;H	;
	DW	0x24	;E	;
	DW	0x31	;N	;
	DW	0x2B	;F	;	
	DW	0x44	;O
	DW	0x4B	;L
	DW	0x34	;G
	DW	0x24	;E
	DW	0x29	;Space
	DW	0x2B	;F
	DW	0x24	;E
	DW	0x1B	;S
	DW	0x2C	;T
	DW	0x4B	;L
	DW	0x24	;E
	DW	0x34	;G
	DW	0x24	;E
	DW	0x31	;N
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0x29	;Space
	DW	0xFF	;Return		;Medung Nr 4


	ORG	2000h
	DW	0xff,0xff,0xff,0xff
	ORG	2007h
        DW      0x3F3A
	end
